PROGRAM VERBMP;

USES CRT,graph;

{-------------------------[ Cabecera del fichero ]-----------------------}

TYPE BitMapHeader=RECORD
  {BitMap File Header}
  bfType:INTEGER;
  bfSize:LONGINT;
  bfReserved1:INTEGER;
  bfReserved2:INTEGER;
  bfOffbits:LONGINT;
  {BitMap Info Header}
  biSize:LONGINT;
  biWidth:LONGINT;
  biHeight:LONGINT;
  biPlanes:INTEGER;
  biBitCount:INTEGER;
  biCompression:LONGINT;
  biSizeImage:LONGINT;
  biXpelsPerMeter:LONGINT;
  biYpelsPerMeter:LONGINT;
  biClrUsed:LONGINT;
  biClrImportant:LONGINT;
  END;

RGBQUAD=RECORD
  rgbBLUE:BYTE;
  rgbGREEN:BYTE;
  rgbRED:BYTE;
  rgbReserved:BYTE;
  END;

CONST CODIF:ARRAY[0..2] OF STRING=('Ninguna','RLE_8','RLE_4');

TYPE
  Paleta  = ARRAY[0..255] OF Record
                              R,G,B:Byte;
                             End;
VAR PAL:Paleta;


{----------------[ Rutinas de utilidad general ]-------------------}

PROCEDURE PAUSA;
VAR CH:CHAR;
BEGIN
REPEAT UNTIL KEYPRESSED;
WHILE KEYPRESSED DO CH:=READKEY;
END;

FUNCTION NUM(A:BYTE):STRING;
VAR S:STRING;
BEGIN
 STR(A,S);
 WHILE LENGTH(S)<8 DO S:=' '+S;
 NUM:=S;
END;


FUNCTION POT(A,B:REAL):INTEGER;
BEGIN
 POT:=ROUND(EXP(B*LN(A)));
END;

{-----[ Rutinas para el modo gr fico VGA 320x200 256 colores ]-----}
Var
pant:array[1..200,1..320] of byte absolute $A000:0000;

PROCEDURE VGA320x200x256;
{ Rutina para inicializar el modo VGA 320x200x256c }
BEGIN
  asm
   mov ax,0013h
   int 10h
  end;
END;

PROCEDURE BAR256(X1,Y1,X2,Y2:WORD;C:BYTE);
VAR Y:BYTE;
BEGIN
 FOR Y:=Y1 TO Y2 DO
      FILLCHAR(PANT[Y,X1],X2-X1,C);
END;

PROCEDURE USAPALETA(VAR P:PALETA);
{Nota: P.R, P.G, P.B deben ser 0<=.<=63}
VAR I,J:BYTE;
BEGIN
  FOR I:=0 TO 255 DO
  BEGIN
    PORT[$3C8]:=I;
    PORT[$3C9]:=P[I].R;
    PORT[$3C9]:=P[I].G;
    PORT[$3C9]:=P[I].B;
  END;
END;

{------[ Rutinas para el modo gr fico VGA 640x480 16 colores ]------}

PROCEDURE VGA640x480x16;
VAR GraphDriver,Modo:integer;
 PROCEDURE TestGraphError(GraphErr: INTEGER);
  BEGIN
    IF GraphErr <> grOk THEN
      BEGIN
        Writeln('Error gr fico : ', GraphErrorMsg(GraphErr));
  	ReadKey;
        Halt(1);
      END;
 END;
BEGIN
  GraphDriver:=VGA;
  Modo:=VGAHi;
  InitGraph(GraphDriver, Modo, 'c:\instala\bgi');
  TestGraphError(GraphResult);
  SetTextJustify(CenterText,CenterText);
END;

PROCEDURE USAPALETA16(VAR P:PALETA);
{ Rutina para definir la paleta de colores activa en modo 640x480 x 16 c. }
{ Utiliza los 16 primeros valores RGB (0<=R,G,B<=63) de P para modificar  }
{ los 16 primeros colores de la paleta y utilizarlos como colores activos }
{-------------------------------------------------------------------------}
{ NOTA:   En EGA y VGA 16 colores, la paleta tiene 64 colores (de 0 a 63) }
{  que se pueden modificar con SETRGBPALETTE, y se pueden utilizar 16 de  }
{  esos colores, que se especifican con SETPALETTE.                       }
{-------------------------------------------------------------------------}
{ NOTA: La ayuda de Turbo Pascal 7.0 tiene algunas erratas acerca de      }
{ SetRGBPalette(ColorNum, RedValue, GreenValue, BlueValue:Integer);       }
{  Para VGA, ColorNum puede estar en 0..63 (no solo en 0..15).            }
{  Son los 6 bits menos significativos de RedValue, GreenValue, BlueValue }
{ los que se tienen en cuenta (no los mas significativos)                 }
{-------------------------------------------------------------------------}
VAR I:integer;
BEGIN
  FOR I:=0 TO 15 DO Begin
                     SetRGBPalette(I,P[I].R,P[I].G,P[I].B);
                     SetPalette(I,I);
                    End;
END;


Type ArrayBuf=ARRAY[1..64000] Of Byte;
VAR InfoHeader:BitMapHeader;
    Colores: RGBQUAD;
    NOMBREARCHIVO:STRING;
    SHOWINFO:boolean;
    ARCH:FILE;
    NCOL:WORD;
    N:longint;
    BUFFER:^ArrayBuf;


PROCEDURE FIN;
BEGIN
 TEXTMODE(LASTMODE);
 CLOSE(ARCH);                        {Cierra el archivo}
 HALT(1);
END;



PROCEDURE LEEPARAMETROS;
BEGIN
IF PARAMCOUNT=0 THEN
  Begin
   WRITELN;
   WRITELN('VISUALIZADOR DE ARCHIVOS .BMP');
   WRITELN;
   WRITELN('Uso del programa: VER_BMP Nombre_archivo.BMP [/I]');
   WRITELN;
   WRITELN('Donde Nombre_archivo es el archivo que se quiere visualizar');
   WRITELN('y /I especifica que se quiere visualizar informacin sobre la imagen.');
   WRITELN;

  END;
 NOMBREARCHIVO:=PARAMSTR(1);
 IF POS('.',NOMBREARCHIVO)=0 THEN NOMBREARCHIVO:=NOMBREARCHIVO+'.BMP';
 IF PARAMCOUNT>1 THEN SHOWINFO:=((PARAMSTR(2)='/I') OR (PARAMSTR(2)='/i'))
                  ELSE SHOWINFO:=FALSE;
END;


PROCEDURE INFOARCH;
BEGIN
{Muestra la informacin de la cabecera}
CLRSCR;
WRITELN ('Informacin del archivo');
WRITELN ('--------------------------------------------------------------------');
WRITELN ('Tipo de archivo...........bfType...........',InfoHeader.bfType);
WRITELN ('Tamao del archivo........bfSize...........',InfoHeader.bfSize);
WRITELN ('Reservado 1...............bfReserved1......',InfoHeader.bfReserved1);
WRITELN ('Reservado 2...............bfReserved2......',InfoHeader.bfReserved2);
WRITELN ('Comienzo de los datos.....bfOffBits........',InfoHeader.bfOffbits);
WRITELN;
WRITELN ('Informacin del Bitmap');
WRITELN ('--------------------------------------------------------------------');
WRITELN ('Tamao de la estructura...biSize...........',InfoHeader.biSize);
WRITELN ('Ancho.....................biWidth..........',InfoHeader.biWidth);
WRITELN ('Alto......................biHeight.........',InfoHeader.biHeight);
WRITELN ('Planos....................biPlanes.........',InfoHeader.biPlanes);
WRITELN ('Bits por pixel............biBitCount.......',InfoHeader.biBitCount);
WRITELN ('Compresin................biCompression....',InfoHeader.biCompression,'= ',Codif[InfoHeader.biCompression]);
WRITELN ('Tamao de la imagen.......biSizeImage......',InfoHeader.biSizeImage);
WRITELN ('Pixels por metro en X.....biXpelsPerMeter..',InfoHeader.biXpelsPerMeter);
WRITELN ('Pixels por metro en Y.....biYpelsPerMeter..',InfoHeader.biYpelsPerMeter);
WRITELN ('Colores utilizados........biClrUsed........',InfoHeader.biClrUsed);
WRITELN ('Colores importantes.......biClrImportant...',InfoHeader.biClrImportant);
WRITELN;
WRITELN ('Pulse una tecla para ver la paleta de colores...');
PAUSA;
END;



{----------------------- VISUALIZACION DE LA PALETA -----------------------}
PROCEDURE MUESTRAPALETA;
VAR X,Y:BYTE;
BEGIN
 case ncol of
       256:begin
            VGA320x200x256;
            USAPALETA(pal);
            FOR Y:=0 TO 15 DO
             FOR X:=0 TO 15 DO
               BAR256(X*320 DIV 16+1,Y*200 DIV 16+1,(X+1)*320 DIV 16+1,
               (Y+1)*200 DIV 16+1,Y*16+X);
           END;
       16:begin
           VGA640x480x16;
           USAPALETA16(Pal);
           OUTTEXTXY(320,50,'PALETA DE COLORES:');
           RECTANGLE(0,99,640,201);
           FOR X:=0 TO 15 DO BEGIN
                             SETFILLSTYLE(SOLIDFILL,X);
                             SETCOLOR(X);
                             BAR(X*640 DIV 16+1,100,(X+1)*640 DIV 16+1,200);
                             END;
           end;
      end;
END;

PROCEDURE INFOCOLORES1;
BEGIN
{Muestra la paleta de colores utilizados por el archivo}
CLRSCR;
WRITELN ('Nmero de colores..........', Ncol);
WRITELN;
WRITELN ('Paleta de colores');
WRITELN ('--------------------------------------------------------------------');
WRITELN;
WRITELN (' # COLOR          ROJO       VERDE        AZUL');
WRITELN (' -------          ----       -----        ----');
END;

PROCEDURE INFOCOLORES2;
BEGIN
  WRITELN(NUM(N-1),'      ',NUM(Colores.rgbRED),'    ',NUM(Colores.rgbGREEN),
  '    ',NUM(Colores.rgbBLUE));
  IF n MOD 16 = 0 THEN
   BEGIN
    WRITELN ; WRITE('Pulse una tecla para continuar...');
     PAUSA;
     IF N<NCOL THEN INFOCOLORES1;
   END;  {IF}
END;

{-------------------- VISUALIZACION CON 256 COLORES -----------------------}
PROCEDURE SHOW256;
Var BYTESPORLINEA:INTEGER;
    offset:longint;
    Y,alto,ancho:longint;
BEGIN

bytesporlinea := 4*((InfoHeader.biWidth + 3) SHR 2);
{Nota: el numero de bytes por linea es multiplo de 4 --> palabras de 32 bits}
OFFSET:=InfoHeader.bfOffbits;
IF INFOHeader.BIHEIGHT>200 THEN
     OFFSET:=InfoHeader.bfOffbits+(INFOHeader.BIHEIGHT-200)*BYTESPORLINEA;

SEEK(ARCH,OFFSET);  {Posiciona el puntero de lectura al inicio}
                   {de la seccin de datos del bitmap que cabe en la pantalla}

VGA320x200x256;       {Establece el modo gr fico 320x200 con 256 colores}
USAPALETA(pal);

 alto:=InfoHeader.biHeight;
 if alto>200 then alto:=200;
 ancho:=bytesporlinea;
 if ancho>320 then ancho:=320;

 FOR y:=alto DOWNTO 1 {Contador de filas del bitmap (invertido)}
 DO BEGIN
    blockread(arch,pant[y,1],ancho);         {copia el archivo a la pantalla}
    seek(arch,FilePos(arch)+bytesporlinea-ancho); {salta el trozo que se sale
                                                  de la pantalla}
    IF KEYPRESSED THEN FIN;
   end;

PAUSA; { Muestra en pantalla el bitmap hasta que se pulse una tecla}
END;

{--------------------- VISUALIZACION CON 16 COLORES -----------------------}
PROCEDURE SHOW16;
Var BYTESPORLINEA:INTEGER;
    offset:longint;
    alto,ancho:longint;
    N,Y:WORD; A,B:BYTE;
BEGIN
bytesporlinea := (InfoHeader.bfSize-InfoHeader.bfOffBits) div InfoHeader.biHeight;

OFFSET:=InfoHeader.bfOffbits;
IF INFOHeader.BIHEIGHT>480 THEN
     OFFSET:=InfoHeader.bfOffbits+(INFOHeader.BIHEIGHT-480)*BYTESPORLINEA;

SEEK(ARCH,OFFSET);  {Situa el puntero de lectura en el inicio de la seccin}
                    {de datos del bitmap que cabe en la pantalla}

VGA640x480x16;     {Establece el modo gr fico 640x480 con 16 colores}
USAPALETA16(Pal);

 alto:=InfoHeader.biHeight;
 if alto>480 then alto:=480;
 ancho:=InfoHeader.biWidth;
 if ancho>640 then ancho:=640;

 getmem(buffer,bytesporlinea);
 FOR y:=alto DOWNTO 1 {Contador de filas del bitmap (invertido)}
 DO BEGIN
   blockread(arch,BUFFER^,BYTESPORLINEA);
   FOR N:=1 TO ANCHO div 2 DO BEGIN
                               IF KEYPRESSED THEN FIN;
                               A:=BUFFER^[N] SHR 4;
                               B:=BUFFER^[N] AND $F;
                               PUTPIXEL(N*2,Y,A);
                               PUTPIXEL(N*2+1,Y,B);
                               END;
  end;
 freemem(buffer,bytesporlinea);

 PAUSA; { Muestra en pantalla el bitmap hasta que se pulse una tecla}
END;


{========================= PROGRAMA PRINCIPAL ============================}
BEGIN
LEEPARAMETROS;

ASSIGN(ARCH,NOMBREARCHIVO);
RESET(ARCH,1);                   {ABRE LA IMAGEN}

{---------------------- LECTURA DE LA CABECERA -------------------------}

BLOCKREAD(ARCH,INFOHeader,SIZEOF(INFOHeader));    {OPTIENE INFO DE LA CABECERA}

{Comprueba si es realmente un archivo BMP "BM = 19778"}

IF InfoHeader.bfType <> 19778 THEN BEGIN
                                 WRITELN('No es un fichero BMP v lido');
                                 HALT(2);
                                 END;

IF SHOWINFO THEN INFOARCH;


{-------------------------- PALETA DE COLORES -----------------------------}

IF InfoHeader.biBitCount = 24 THEN
       BEGIN
        IF SHOWINFO THEN
            WRITELN ('Al ser una imagen de 24 bits no tiene paleta de colores.');
        ncol:=0;
       end

ELSE
 BEGIN
    {Calcula el nmero de colores utilizados en la imagen}
    IF InfoHeader.biClrUsed = 0  THEN  ncol:=POT(2,InfoHeader.biBitCount)
                                 ELSE  ncol:=InfoHeader.biClrUsed;

    IF SHOWINFO THEN INFOCOLORES1;
    getmem(buffer,4*ncol);
    BLOCKREAD(ARCH,BUFFER^,4*NCOL);
    FOR n:= 1 TO ncol DO
      BEGIN
        Colores.rgbRED:=buffer^[4*(n-1)+3];
        Colores.rgbGREEN:=buffer^[4*(n-1)+2];
        Colores.rgbBLUE:=buffer^[4*(n-1)+1];
        {Nota: Los valores R,G,B de la paleta en el fichero son 0<=.<=255}
        {Pero en VGA deben ser 0<=.<=63}
        PAL[N-1].R:=Colores.rgbRED shr 2;
        PAL[N-1].G:=Colores.rgbGREEN shr 2;
        PAL[N-1].B:=Colores.rgbBLUE shr 2;
        IF SHOWINFO THEN INFOCOLORES2;
     END;

    freemem(buffer,4*ncol);
    IF SHOWINFO THEN BEGIN
                     MUESTRAPALETA;
                     PAUSA;
                     END;
END; {ELSE}

{------------------------- VISUALIZACION LA IMAGEN --------------------------}
CASE NCOL OF
          256:SHOW256;
          16:SHOW16;
     ELSE BEGIN
           WRITELN;
           WRITELN ('Slo se pueden visualizar BMP con 256 o 16 colores.');
           HALT(3);
          END;
     END; {CASE}
  fin;
END.

