{*********************************************************************
                         UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
  comentarios: esta unidad es muy importante.
  contiene rutinas para el mouse y control de las entradas del teclado.
*********************************************************************}
{F+} {Activa las llamadas lejenas}
{O+} {Define recubrimiento}
Unit Eventos;
Interface
Uses Crt,dos;
{   cdigos devuelto por la funcin ObtenerEntrada

  Cdigos del teclado:

    #8      Retroceso
    #9      Tabulacin
    #13     Enter
    #27     Escape
    #143    Shift + Tabulacin
    #211    Suprimir
    #207    Fin
    #199    Inicio
    #210    Insertar

  Cdigos del Mouse:

    #128    Se produce cuando el Mouse se mueve para arriba
    #129    "    "      "     "     "  "    "     "  abajo
    #130    "    "      "     "     "  "    "     "  la Izquierda
    #131    "    "      "     "     "  "    "     "  la Derecha
    #132    "    "      "     se presiona el boton derecho   del Mouse
    #133    "    "      "     se presiona el boton izquierdo  "    "
    #134    "    "      "     se presiona el boton Medio      "    "
}
Type TMouseBoton = (NoBt,Izq,Der,Med);


Var
 ASCIIExtendido : boolean;
 MouseVisible : boolean;


 procedure IniciarRaton;
 function  MouseTexto: boolean;
 procedure EvMostrarMouse;
 procedure EvOcultarMouse;
 function  MouseInstalado : boolean;
 procedure EvMouseBoton (Var b : TMouseBoton);
 function  EvMouseBtn:byte;
 function  MouseX : Word;
 function  MouseY : Word;
 procedure MouseMaxX (x:word);
 procedure MouseMaxY (y:word);
 function  evTecla : boolean;
 function evLeeTecla :char;
 function  EvCapturar : char;


implementation

 procedure IniciarRaton;assembler;
 asm
  Mov Ax,$0
  Int $33
 end;

 Function  MouseTexto: boolean;
 Var M : byte;
 begin
   asm
    Mov AH,$0F
    Int $10
    Mov M,AL
   end;
   MouseTexto := (M < $10)
 end;

 Procedure EvMostrarMouse;
 begin
   asm
    Mov Ax,$01
    Int $33
   end;
  MouseVisible := true
 end;

 Procedure EvOcultarMouse;
 Begin
   Asm
    Mov Ax,$02
    Int $33
   end;
  MouseVisible := false
 end;

 Function MouseInstalado : boolean;
 Var n : Integer;
 begin
   asm
    Mov AX,$0
    Int $33
    Mov n,AX
   end;
   MouseInstalado := n <> 0
 end;

 procedure EvMouseBoton (Var B : TMouseBoton);
 Var n : Word;
 begin
   asm
    Mov AX,$3
    Int $33
    Mov n,BX
   end;
   Case n of
     0 : B := NoBt;
     1 : B := Izq;
     2 : B := Der;
     4 : B := Med
   end
 end;

 Function  EvMouseBtn:byte;
 var
   B : Word;
 Begin
   asm
    Mov Ax, $3
    Int $33
    Mov B,Bx
   end;
   EvMouseBtn := B;
 end;


 Function  MouseX : Word;
 Var x : Word;
 begin
   Asm
    Mov Ax,$03
    Int $33
    Mov x, Cx
   end;
   if MouseTexto then
     MouseX := x Div 8 + 1
   else
     MouseX := x + 1
 end;

 Function  MouseY : Word;
 Var y : Word;
 begin
   Asm
    Mov Ax,$03
    Int $33
    Mov y, Dx
   end;
   if MouseTexto then
     MouseY := y div 8 + 1
   else
     MouseY := y + 1;
 end;

 procedure MouseMaxX (x:word);Assembler;
 asm
   MOV AX,$07
   MOV CX,$00
   MOV DX,X
   INT $33
 end;

 procedure MouseMaxY (y:word);Assembler;
 asm
   MOV AX,$08
   MOV CX,$00
   MOV DX,y
   INT $33

 end;

 function  evTecla : boolean;
 var t : byte;
 begin
   asm
     MOV AH, $11
     INT 16
     MOV t, al
   end;
   if t = 0 then
    evTecla := false
   else
    evTecla := true
 end;

 function evLeeTecla :char;
 var ch : char;
 begin
   asm
     MOV AH, $10
     INT $16
     MOV ch, AL
   end;
   evLeeTecla := ch
 end;

 function EvCapturar : char;
 var
    Entrada : char;
    Boton : TMouseBoton;
    CoorVer,CoorHor : Word;
    x,y : Word;
    FinEntrada,FinEntradaMouse : Boolean;
 begin
   FinEntrada := False;
   FinEntradaMouse := false;
   Boton := NoBt;
   x := MouseX;
   y := MouseY;

   repeat
     EvMouseBoton (Boton);
     CoorHor := MouseX;
     CoorVer := MouseY;
     case Boton of
       Izq : begin
               Entrada := #133;
               FinEntrada := true
             end;
       Der : begin
               Entrada := #132;
               FinEntrada := true
             end;
       Med : begin
               Entrada := #134;
               FinEntrada := true
             end;
     end;{case}

    if CoorHor > x then
    begin
      Entrada := #131;
      FinEntrada := true
    end
     else
        if CoorHor < x then
        begin
          Entrada := #130;
          FinEntrada := true
        end
         else
            if CoorVer > y then
            begin
              Entrada := #129;
              FinEntrada := true
            end
            else
               if CoorVer < y then
               begin
                 Entrada := #128;
                 FinEntrada := true
               end;
     if KeyPressed or FinEntrada then
       FinEntradaMouse := true;

     if FinEntrada then
       ASCIIExtendido := true;

   until FinEntradaMouse;

   while not FinEntrada do
   begin
     FinEntrada := true;
     Entrada := ReadKey;
     if Entrada = #0 then
     begin
       Entrada := ReadKey;
       ASCIIExtendido := true;
       case ord(Entrada) of
        15,
        16..25,
        30..38,
        44..50,
        59..68,
        71..73,
        75,77,
        79..127  : Entrada := chr(ord(Entrada) + 128);

        128..140 : Entrada := chr(ord(Entrada) + 7);
        else
            FinEntrada := false
        end{Case}
     end{if}
      else
          ASCIIExtendido := false
   end;{while}
   EvCapturar := Entrada;
 end;{EvCapturar}

end.