Unit UTBmp2;

Interface
Uses Graph;

Type
	TBmpInfo = record
		    EsBmp : array[0..1] of char;
		    FileSize : longint;
		    Reservado01, Reservado02 : word;
                    PosImagen : longint;
 		   end;

	TBmpWin = record
		   Tamano : longint;
                   Ancho : longint;
                   Alto : longint;
                   Planos : word;
                   Bits : word;
                   Compresion : longint;
                   ImgTamano : longint;
                   XPxlPorMetro : longint;
                   YPxlPorMetro : longint;
                   ColoresUsados : longint;
                   ColoresImport : longint;
                 end;

	TRGBWin = record
                   Azul, Verde, Rojo : byte;
                   Reservado : byte;
		  end;

	TBmpOS2 = record
                   Tamano : longint;
                   Ancho : word;
                   Alto : word;
                   Planos : word;
                   Bits : word;
                 end;

	TRGBOS2 = record
                   Azul, Verde, Rojo : byte;
		  end;

	TBitmap = record
                   Bits : byte;
                   Ancho, Alto : word;
                   Paleta : array[0..255] of TRGBOS2;
                   Imagen : pointer;
		  end;

 procedure CargarBMP(const Archivo : string; var BMP : TBitmap);
 procedure MostrarBmp(BMP : TBitmap);

Implementation

 procedure CargarImg(Img : pointer; Ancho, Alto, Agregados : word; Pos : longint; var f : file);
 var
  ImgS, ImgO, ActO : word;
 begin
   ImgS := Seg(Img^);
   ImgO := Ofs(Img^);
   ActO := ImgO + (Ancho * (Alto - 1));
   while (Alto >0) do
   begin
     Img := Ptr(ImgS, ActO);
     BlockRead(f, Img^, Ancho);
     ActO := ActO - Ancho;
     Alto := Alto - 1;
     Seek(f, FilePos(f) + Agregados);
   end;
 end;

 procedure CargarImgComp(Img : pointer; Ancho, Alto : word; Pos : longint; var f : file);
 var
   ImgS, ImgO, ActO, LinO : word;
   Dat, Color, X, Y, Cant : byte;
   Termino : boolean;
 begin
   ImgS := Seg(Img^);
   ImgO := Ofs(Img^);
   ActO := ImgO + (Ancho * Alto);
   for LinO := ImgO to ActO do
     Mem[ImgS:LinO] := 0;
   LinO := LinO - Ancho;
   ActO := LinO;
   Termino := False;
   while (not Termino) do
   begin
     BlockRead(f, Dat, 1);
     if (Dat > 0) then
     begin
       BlockRead(f, Color, 1);
       while (Dat > 0) do
       begin
         Mem[ImgS:ActO] := Color;
         ActO := ActO + 1;
         Dat := Dat - 1;
       end;
     end
     else
      begin
	BlockRead(f, Dat, 1);
	case Dat of
     	  0 : begin
		LinO := LinO - Ancho;
                ActO := LinO;
              end;

          1 : Termino := True;

          2 : begin
		BlockRead(f, x, 1);
		BlockRead(f, y, 1);
		LinO := LinO - (Ancho * y);
		ActO := ActO - (Ancho * y) + x;
	      end;
	else
	begin
   	  Cant := Dat;
	  while (Cant > 0) do
	  begin
  	    BlockRead(f, Color, 1);
            Mem[ImgS:ActO] := Color;
            ActO := ActO + 1;
            Cant := Cant - 1;
	  end;
	  if (Dat Mod 2 <> 0) then
	   BlockRead(f, Dat, 1);
	end;
      end;
     end;
   end;
 end;

 procedure CargarBMP(const Archivo : string; var BMP : TBitmap);
 var
    BmpInfo : TBmpInfo;
    BmpWin : TBmpWin;
    BmpOS2 : TBmpOS2;
    PalWin : array[0..255] of TRGBWin;
    Win_OS2 : longint;
    Aux : byte;
    f : file;
    Relleno : word;
 begin
   Assign(f, Archivo);
   Reset(f, 1);
   BlockRead(f, BmpInfo, SizeOf(TBmpInfo));
   if (BmpInfo.EsBmp[0] = 'B') and (BmpInfo.EsBmp[1] = 'M') then
   begin
     BlockRead(f, Win_OS2, 4);
     Seek(f, SizeOf(TBmpInfo));
     if (Win_OS2 = SizeOf(TBmpWin)) then
     begin
       BlockRead(f, BmpWin, SizeOf(TBmpWin));
       Bmp.Ancho := BmpWin.Ancho;
       Bmp.Alto := BmpWin.Alto;
       Bmp.Bits := BmpWin.Bits;
       if (BmpWin.Bits = 8) then
       begin
	 BlockRead(f, PalWin, SizeOf(TRGBWin) * 256);
         for Aux := 0 to 255 do
	 begin
	   Bmp.Paleta[Aux].Rojo := PalWin[Aux].Rojo;
           Bmp.Paleta[Aux].Verde := PalWin[Aux].Verde;
           Bmp.Paleta[aux].Azul := PalWin[Aux].Azul;
	end;
       Relleno := (BmpWin.ImgTamano Div Bmp.Alto) - Bmp.Ancho;
       GetMem(Bmp.Imagen, Bmp.Ancho * Bmp.Alto);
       if (BmpWin.Compresion = 0) then
	CargarImg(Bmp.Imagen, Bmp.Ancho, Bmp.Alto, Relleno, BmpInfo.PosImagen, f)
       else
	CargarImgComp(Bmp.Imagen, Bmp.Ancho, Bmp.Alto, BmpInfo.PosImagen, f);
       end
       else
	if (BmpWin.Bits = 24) then
	begin
          Relleno :=(BmpWin.ImgTamano Div Bmp.Alto) - (Bmp.Ancho * 3);
          GetMem(Bmp.Imagen, Bmp.Ancho * Bmp.Alto * 3);
          CargarImg(Bmp.Imagen, Bmp.Ancho * 3, Bmp.Alto, Relleno, BmpInfo.PosImagen, f);
	end;
       end
       else
       begin
	 BlockRead(f, BmpOS2, SizeOf(TBmpOS2) * 256);
         Bmp.Ancho := BmpOS2.Ancho;
         Bmp.Alto := BmpOS2.Alto;
         Bmp.Bits := BmpOS2.Bits;
         if (Bmp.Bits = 8) then
         begin
           BlockRead(f, Bmp.Paleta, SizeOf(TRGBOS2));
           Relleno := Bmp.Ancho Div 4;
           if (Bmp.Ancho Mod 4 <> 0) then
            Relleno := Relleno + 1;
           Relleno := (Relleno * 4) - Bmp.Ancho;
           GetMem(Bmp.Imagen, Bmp.Ancho * Bmp.Alto);
           CargarImg(Bmp.Imagen, Bmp.Ancho, Bmp.Alto, Relleno, BmpInfo.PosImagen, f);
	end
	else
          if (Bmp.Bits = 24) then
          begin
	    Relleno := (Bmp.Ancho * 3) Div 4;
            if ((Bmp.Ancho * 3) Mod 4 <> 0) then
             Relleno := Relleno + 1;
            Relleno := (Relleno * 4) - (Bmp.Ancho * 3);
            GetMem(Bmp.Imagen, Bmp.Ancho * Bmp.Alto * 3);
            CargarImg(Bmp.Imagen, Bmp.Ancho * 3, Bmp.Alto, Relleno, BmpInfo.PosImagen, f);
          end;
        end;
       end;
       Close(f);
 end;

 procedure MostrarBmp(BMP : TBitmap);
 var
  x, y : integer;
  imgS, imgO_1, imgO_2, imgO_A : word;
  aux : byte;
 begin
   if (Bmp.Bits = 8) then
   begin
     ClearDevice;
     for aux := 0 to 255 do
      SetRGBPalette(aux, Bmp.Paleta[aux].Rojo div 4, Bmp.Paleta[aux].Verde div 4, Bmp.Paleta[aux].Azul div 4);
     imgS := Seg(Bmp.Imagen^);
     imgO_1 := Ofs(Bmp.Imagen^);
     imgO_2 := imgO_1 + (Bmp.Ancho * Bmp.Alto);
     x := 0;
     y := 0;
     for imgO_A := imgO_1 to imgO_2 do
     begin
       PutPixel(x, y, Mem[imgS:imgO_A]);
       if (x = Bmp.Ancho - 1) then
       begin
         x := 0;
         y := y + 1;
       end
       else
	x := x + 1;
       end;
     end;
end;

end.
