{*********************************************************************
                         UniGrapa
           -- unidad de graficos para pascal --
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
  comentarios:
              Recordando la programcin en el elgante y fabuloso
              Turbo/Borland Pascal 7.0, me di cuenta de que; ahora
              en  estos  tiempos  de  los  copiladores y lenguajes
              visuales, la creacin de una interface de usuario para
              las aplicaciones, nisiquiera es un trabajo para
              profesionales, pues es como hacer un dibujo, y cambiar
              uno que otro valor. Es increible que la mayoria de los
              programadores graduados en estos ultimos tiempos, no
              estan preparados para crear nuevas tecnologas que
              puedan establecer mejores patrones y esquemas en el
              mundo de los sistemas informaticos.
              Estos "profesionales" solo se dedican a relizar sistemas
              administrativos y cosas por el estilo.
              No se dan cuenta de la importancia de crear tecnologa
              que cambie los esquemas como los impuestos por Microsoft,
              que no te permiten disfrutar de sus "Nuevos" Softwares si
              no cancelas las altas cantidades que piden por ello, y
              que adems te exigen tener PC de ultima generacin.
              y si quisieras aprender un poco de estos pues te demandan,
              o te quitan tus ideas y se hacen millonarios con ellas.

              Debemos apoyar todos los proyectos GNU existentes,
              ya que estos nos permiten aprender sin ser demandados,
              y ofrecer sin que preocupe nos quiten lo que mas valor
              puede tener: el reconocimiento de todos por nuestra labor.

              Yo reconosco el trabajo de Stallman y quizas a Linus Torvalds
              y el de todos los que junto a ellos crearon GNU/Linux.

              Gracias por haber acercado la luz...
              Atrevete a ser libre...
 *********************************************************************}
{$O+}
{$F+}
unit UTAPLI;

interface
uses Graph, Eventos, crt;
type
{***********************************************************************
 Declaracion del objeto TObjeto
   este tipo es usado por los controles para crear una lista con la que
   se pueda controlar y realizar llamdas a las acciones de estos objetos.
***********************************************************************}
    TipoEv = (Usuario, Objeto, nulo);

    ObjetoPtr  = ^TObjeto;{puntero a TObjeto}

    TObjeto  = Object
                  constructor Crear;
                  destructor Destruir;virtual;
                  function ManEv(tipo:TipoEv; Ev:char;var Resp:boolean):char;virtual;
                  procedure Actualizar;virtual;
                 private
                   Enlace : ObjetoPtr;
                 end;

    TLista = object (TObjeto)
               destructor Destruir;virtual;
               procedure Actualizar;Virtual;
               procedure Agregar (obj : ObjetoPtr);Virtual;
               procedure Sacar (obj : ObjetoPtr);Virtual;
               function Actual : ObjetoPtr;
               procedure siguiente;
              private
               ObjActual, Inicio : ObjetoPtr;
             end;

    ControlPtr = ^TControl;

    TControl = object(TLista)
                  X, Y, MaxX, MaxY : word;
                  constructor crear (x1, y1,x2,y2:word);
                  destructor Destruir;virtual;
                  function CaptEv : char;Virtual;
                 private
                  vCreado : boolean;
               end;

{tipo usado para establecer el tipo de letra su color tamao y direccin }
     TFuente = record
               Color:byte;
               Direccion : byte;
               Estilo:Byte;
               Tamano:byte;
             end;


const

{cdigos del teclado}
    cRetro   = #8;  {Retroceso - BackSpace}
    cTab     = #09; {Tabulacin}
    cEnter   = #13; {Entrar - Enter}
    cEsc     = #27; {Escape}
    cInicio  = #199;{Cursor a Inicio - Home}
    cFlchArr = #200;{Cursor arriba}
    cFlchIzq = #203;{Cursor a la Izquierda}
    cFlchDer = #205;{Cursor a la Derecha}
    cFin     = #207;{Fin - End}
    cFlchAbj = #208;{Cursor Abajo}
    cInsertar= #210;{Insertar - Insert}
    cSupr    = #211;{Suprimir - Del}

{cdigos extendidos producidos por el mouse}
    cMouseArr =  #128;{Mouse Arriba}
    cMouseAbj =  #129;{Mouse Abajo}
    cMouseIzq =  #130;{Mouse a la izquierda}
    cMouseDer =  #131;{Mouse a la derecha}
    cMouseCli =  #133;{Mouse click}

  {Fuente bsica para el ttulo del formulario}
  FuenteTitulo : TFuente = (Color:15; Direccion:0; Estilo:0; Tamano:0);

  {lista de colores para los controles grficos}
  MapColor : array [0..9] of word ={0}(07,{color por defecto del fromulario}
                                    {1}07,{color por defecto del boton}
                                    {2}15,{color del borde izquierdo}
                                    {3}00,{color del borde derecho}
                                    {4}00,{color del marco}
                                    {5}01,{color titulos form}
                                    {6}00,{color texto btn}
                                    {7}01,{seleccion}
                                    {8}15,{entradas de texto}
                                    {9}00);{texto}

 procedure IniciarModoGrafico;
Implementation
 {***********************************************************************
               Metodos del objeto TObjeto
  ***********************************************************************}
  constructor TObjeto.Crear;
  begin
  end;

  destructor TObjeto.Destruir;
  begin
  end;

  function TObjeto.ManEv (Tipo : TipoEv; Ev : char;var resp: boolean): char;
  begin
    ManEv := #0;
    Resp := false
  end;

  procedure TObjeto.Actualizar;
  begin
  end;

 {***********************************************************************
               Metodos del objeto TLista
  ***********************************************************************}

 destructor TLista.Destruir;
 begin
   while Inicio <> nil do
   begin
     Inicio^.Destruir;
     Inicio := Inicio^.enlace
   end;
   inicio := nil
 end;

 procedure TLista.Actualizar;
 var
  p : ObjetoPtr;
 begin
   p := inicio;
   while p <> nil do
   begin
     p^.Actualizar;
     p := p^.enlace;
   end;
 end;

 procedure TLista.Agregar (obj : ObjetoPtr);
 var
  p:ObjetoPtr;
 begin
   p := Obj;
   p^.enlace := Inicio;
   Inicio:= p;
   ObjActual := inicio;
 end;

 procedure TLista.Sacar (obj : ObjetoPtr);
 var p : ObjetoPtr;
 begin
   if Obj = Inicio then
    Inicio := Inicio^.Enlace
   else
     begin
       p := Inicio;
       while p^.enlace <> Obj do
        p := p^.enlace;
       p^.enlace := Obj^.enlace;
       inicio:= p;
       ObjActual := inicio
     end;
 end;

 function TLista.Actual : ObjetoPtr;
 begin
   Actual := ObjActual
 end;

 procedure TLista.siguiente;
 begin
   ObjActual := ObjActual^.Enlace
 end;
 {***********************************************************************
               Metodos del objeto TControl
  ***********************************************************************}

 constructor TControl.crear (x1,y1,x2,y2:word);
 begin
   inherited Crear;
   X := x1;
   Y := y1;
   MaxX := x2;
   MaxY := y2;
   vCreado := true
 end;

 destructor TControl.Destruir;
 begin
   if vcreado then
   begin
    inherited Destruir;
    vCreado := false
  end;
 end;

 function Tcontrol.CaptEv :char;
 var
  Ev, Aux : char;
  resp: boolean;
  p : ObjetoPtr;
 begin
   if vCreado then
   begin
     Ev := evCapturar;
     CaptEv := Ev;
     ManEv (Usuario,Ev, resp);
     if Actual <> nil then
     begin
       aux := Actual^.ManEv (Usuario, Ev, Resp);
       if Resp then
        ManEv (objeto, Aux, Resp)
       else
        case ev of
          ctab :begin
                  siguiente;
                  if Actual <> nil then
                    Aux := Actual^.ManEv (usuario, cTab , resp)
                  else
                  begin
                    ObjActual := inicio;
                    Aux := Actual^.ManEv (usuario, cTab , resp)
                  end;
                  while (Aux = #0) and (Resp = false) and (actual <> nil) do
                  begin
                    siguiente;
                    if Actual <> nil then
                     Aux := Actual^.ManEv (usuario, cTab , resp);
                  end;
                end;

          #133 : begin
                   p := inicio;
                   while p <> nil do
                   begin
                     aux := p^.ManEv (usuario, ev, resp);
                     if Resp then
                     begin
                       if aux = #0 then
                         ObjActual := p;
                       ManEv (objeto, aux, resp);
                       Break
                     end
                     else
                       p := p^.Enlace
                   end;
                 end;
        end;
     end
     else
       ObjActual := inicio;
   end
   else
    CaptEv := #0
 end;


 procedure EGAVGA;External;{driver EgaVga.bgi}
  {$L EGAVGA.obj}

 procedure Solucionar_Error;
 begin
   Writeln('driver no encontrado. presione enter');
   readln;
   Halt(1);
 end;

 procedure IniciarModoGrafico;
 var
  Driver,Modo,CodigoError: Integer;
 begin
   RegisterBgiDriver (@EGAVGA);
   Driver := 0;
   Modo   := 0;
   InitGraph (Driver,Modo,'');
   CodigoError := GraphResult;
   if CodigoError  = grOk then
     Writeln ('Modo Grafico [ OK ]')
   else
     Solucionar_Error;
   SetFillStyle (9, 7);
   bar (1,1,GetMaxX, GetMaxY);
   IniciarRaton;
   EvMostrarMouse;
   MouseMaxX (GetMaxX-1);
   MouseMaxY (GetMaxY-1);
 end;

begin
  iniciarModoGrafico
end.{Fin de la unidad UTApli}