{*********************************************************************
                         UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTbtn;
interface
uses UTApli,Graph,Eventos;

type
     BtnPtr = ^TBtn;

     TBtn = object (TObjeto)
                 EvMouseDentro, EvAccion : char;
                 constructor Crear(x1, y1 : word; s: string; ca: char;Ctrl:ControlPtr);
                 destructor Destruir;virtual;
                 procedure Actualizar;Virtual;
                 function ManEv (Tipo : TipoEv; Ev: char;var resp:boolean): char;Virtual;
               public
                 procedure Titulo (t : string);
                 procedure Costado (c : word);
                 procedure Tope (t : word);
                 procedure Largo (l: word);
                 procedure Alto (a : word);
                 procedure Fuente (f : TFuente);
                 procedure Color (c : Byte);
                 procedure Textura (t : byte);
                 procedure habilitado (e : boolean);
                 procedure BordeEstilo (bs : char);
                 function MouseDentro : boolean ;
               private
                MinX, MinY, MaxX, MaxY : word;
                CorX1, CorY1, CorX2, CorY2 : word;
                vTitulo : string;
                vCostado, vTope, vLargo, vAlto : word;
                vColor,vTextura :byte;
                vFuente : TFuente;
                vhabilitado : boolean;
                vBordeEstilo : char;
                CtrlPtr : ControlPtr;
                Creado, resaltado:boolean;
                X1Ant,Y1Ant, X2Ant, Y2Ant : word;
                ImagenAnt : pointer;
                TamanoImagen : word;
                foco : boolean;
                procedure pintar (t : byte);
                procedure Refrescar;
                procedure Marcar;
                procedure DesMarcar;
                function  XMedio:word;
                function  YMedio:word;
                function Pulsado : boolean;
              end;


implementation

{///////////////////////////////////////////////////////////////////////
 Procedimientos realacionados con el objeto Boton
///////////////////////////////////////////////////////////////////////}
 constructor TBtn.Crear(x1, y1 : word; s:string;ca:char;Ctrl:ControlPtr);
 begin
   vCostado := x1;
   vTope := y1;
   vTitulo := s;
   evAccion := ca;
   CtrlPtr := Ctrl;
   Refrescar;
   Creado := true;
   EvOcultarMouse;
   TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
   GetMem (ImagenAnt,TamanoImagen);
   GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
   X1Ant := CorX1 - MinX;
   Y1Ant := CorY1 - MinY;
   X2Ant := MaxX - CorX2;
   Y2Ant := MaxY - CorY2;
   evMostrarMouse;
   Actualizar
 end;

 destructor TBtn.Destruir;
 begin
   if creado then
   begin
     EvOcultarMouse;
     PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
     EvMostrarMouse;
     FreeMem (ImagenAnt,TamanoImagen);
     Creado := false;
   end
 end;

 procedure TBtn.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     EvOcultarMouse;
     if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
        ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
     begin
       PutImage (MinX + X1Ant, MinY + Y1Ant, ImagenAnt^, NormalPut);
       X1Ant := CorX1 - MinX;
       Y1Ant := CorY1 - MinY;
       X2Ant := MaxX - CorX2;
       Y2Ant := MaxY - CorY2;
       FreeMem (ImagenAnt, TamanoImagen);
       TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
       GetMem (ImagenAnt, TamanoImagen);
       GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
     end;
     if not MouseVisible then
      EvMostrarMouse;
     Pintar(0)
  end
 end;

 function TBtn.ManEv (Tipo : TipoEv; Ev: char;var resp:boolean) : char;
 begin
   if creado then
    case tipo of
     Usuario : case ASCIIExtendido of

                  true  : case Ev of
                           cMouseCli :if MouseDentro then
                                      begin
                                        if pulsado then
                                         ManEv := EvAccion;
                                        resp := true
                                       end
                                       else
                                        begin
                                          ManEv := Ev;
                                          resp := false;
                                      end;

                          #128..#131 : if MouseDentro then
                                       begin
                                         ManEv := EvMouseDentro;
                                        resp := true
                                       end
                                       else
                                       begin
                                         ManEv := Ev;
                                         resp := false
                                       end;
                        else
                           ManEv := Ev;
                           Resp := false
                        end;{caso ev con ASCII true}

                 false : case Ev of

                           cEnter : begin
                                      ManEv := EvAccion;
                                      resp := true
                                   end;
                           cTab : if foco then
                                  begin
                                    DesMarcar;
                                    ManEv := cTab;
                                    Resp := false
                                  end
                                  else
                                  begin
                                    Marcar;
                                    ManEv := #0;
                                    Resp := true
                                  end
                         else
                           ManEv := Ev;
                           Resp := false
                         end;

               end;{fin caso ASCIIExtendido}
   end;{fin tipo}
 end;

 procedure TBtn.Titulo (t : string);
 var
  h: word;
  i : byte;
 begin
   vTitulo := t;
   if creado then
   begin
     EvOcultarMouse;
     SetFillStyle (vTextura,MapColor[1]);
     bar (CorX1+3, CorY1+3, CorX2-3, CorY2-3);
     with vFuente do
      SetTextStyle (Estilo, Direccion, Tamano);
     setColor (vFuente.Color);
     OutTextXY(XMedio - ((TextWidth (vTitulo)*50) div 100),
               YMedio - ((TextHeight(vTitulo)*50) div 100), vtitulo);

     EvMostrarMouse
   end
 end;

 procedure TBtn.Costado (c : word);
 begin
   if (c > 0) and (c < MaxX) then
    vCostado := c
   else
     vCostado := 1
 end;

 procedure TBtn.Tope (t : word);
 begin
   if (t > 0) and (t < MaxY) then
    Vtope := t
   else
     Vtope := 1
 end;

 procedure TBtn.Largo (l: word);
 var
  vDefecto : word;
 begin
   vLargo := l;
   if creado then
   begin
     with VFuente do
      SetTextStyle (Estilo, Direccion, Tamano);

      vDefecto := Textwidth (vTitulo)+7;
      vDefecto := vDefecto + ((vDefecto * 20) div 100);

      if (l > ((vDefecto * 50) div 100)) and (vCostado + l < MaxX) then
       vLargo := l
      else
      begin
        vLargo := 0;
        while(vCostado + vLargo < vCostado + vDefecto ) and
             (vCostado + vLargo < MaxX) do
          inc (vLargo)
      end
   end
 end;

 procedure TBtn.Alto (a : word);
 var
   vDefecto : word;
 begin
   vAlto := a;
   if creado then
   begin
     with VFuente do
      SetTextStyle (Estilo, Direccion, Tamano);
     vDefecto := TextHeight (vTitulo)+7;
     vDefecto := vDefecto + ((vDefecto * 50) div 100);

     if (a > (Vdefecto * 50) div 100) and (vtope + a < MaxY) then
      vAlto := a
     else
     begin
       vAlto := 0;
       while  (vTope + vAlto < vTope + vDefecto) and
              (vTope + vAlto < MaxY) do
        inc (vAlto)
     end
   end;
 end;

 procedure TBtn.Fuente (f : TFuente);
 begin
   if f.Color = 0 then
   begin
    vFuente := FuenteTitulo;
    vFuente.Color := MapColor [6]
   end
 end;

 procedure TBtn.Color (c : Byte);
 begin
   if (c > 0) and (c < GetMaxColor) then
    vColor := c
   else
    vColor := MapColor[1]
 end;

 procedure TBtn.Textura (t : byte);
 begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
 end;

 procedure TBtn.habilitado (e : boolean);
 begin
    vHabilitado := e
 end;

 procedure TBtn.BordeEstilo (bs : char);
 begin
   if bs in [#0..#3] then
    vBordeEstilo := bs
 end;

 function TBtn.MouseDentro : boolean ;
 begin
   if ((MouseY >= CorY1) and (MouseY <= CorY2) and
       (MouseX >= CorX1) and (MouseX <= CorX2))then
     MouseDentro := true
   else
     MouseDentro := false
 end;

 procedure TBtn.pintar (t : byte);
 var c:byte;
 begin
   if MouseDentro then
    EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   case foco of
     true : c := 0;
     false: c := MapColor[2];
   end;
   SetColor (c);
   rectangle (CorX1,CorY1,CorX2,CorY2);
   case foco of
     true : c := 0;
     false: c := MapColor[3];
   end;
   SetColor (c);
   rectangle (CorX1+1,CorY1+1,CorX2-1,CorY2-1);
   case t of
     0 : begin
           case vBordeEstilo of
            #0 : SetColor (MapColor[2]);
           end;

           Line (CorX1+2,CorY1+2,CorX2-2,CorY1+2);
           Line (CorX1+2,CorY1+2,CorX1+2,CorY2-2);

           case vBordeEstilo of
            #0 : SetColor (MapColor[3]);
           end;

           Line (CorX2-2,CorY1+2,CorX2-2,CorY2-2);
           Line (CorX1+2,CorY2-2,CorX2-2,CorY2-2);
         end;

    1 : begin
          SetColor (MapColor[3]);
          Line (CorX1+2,CorY1+2,CorX2-2,CorY1+2);
          Line (CorX1+2,CorY1+2,CorX1+2,CorY2-2);
          SetColor (MapColor[2]);
          Line (CorX2-1,CorY1+1,CorX2-1,CorY2-1);
          Line (CorX1+1,CorY2-1,CorX2-1,CorY2-1);
        end;
   end;
   if not MouseVisible then
    EvMostrarMouse;
   Titulo (vTitulo);
  end;

 procedure TBtn.Refrescar;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Textura (vTextura);
   Fuente (VFuente);
   BordeEstilo (vBordeEstilo);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
 end;

 procedure TBtn.Marcar;
 begin
   EvOcultarMouse;
   SetColor (0);
   rectangle (CorX1+1,CorY1+1,CorX2-1,CorY2-1);
   rectangle (CorX1, CorY1, CorX2, CorY2);
   EvMostrarMouse;
   foco := true
 end;

 procedure TBtn.DesMarcar;
 var c: byte;
 begin
   foco := false;
   EvOcultarMouse;
   SetColor (MapColor[2]);
   rectangle (CorX1, CorY1, CorX2, CorY2);
   case foco of
     true : c := 0;
     false: c := MapColor[2];
   end;
   SetColor (c);
   rectangle (CorX1,CorY1,CorX2,CorY2);
   case foco of
     true : c := 0;
     false: c := MapColor[3];
   end;
   SetColor (c);
   rectangle (CorX1+1,CorY1+1,CorX2-1,CorY2-1);
   EvMostrarMouse;
 end;

 function  TBtn.XMedio:word;
 begin
   XMedio := (CorX1 + CorX2) div 2
 end;

 function  TBtn.YMedio:word;
 begin
   YMedio := (CorY1 + CorY2) div 2
 end;

 function TBtn.Pulsado : boolean;
 begin
   repeat
     if MouseDentro then
     begin
       Pintar (1);
       repeat  until (EvMouseBtn <> 1) or (MouseDentro = false);
     end
      else
       begin
         Pintar (0);
         repeat  until (EvMouseBtn <> 1) or (MouseDentro);
       end;
   until EvMouseBtn <> 1;
   Pintar (0);
   Pulsado := MouseDentro
 end;
end.