{*********************************************************************
                         UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTDlgs;
interface
uses Eventos, UTApli, UTForm, UTEtiq, UTBtn, UTEdit;

const
{constantes usadas por los diferentes dialogos}
  evSi = #01;
  evNo = #02;

  Ancho      = 25; {constante para el ancho de los botones}
  Separacion = 30; {constantes para la separacin entre los botones}
  CorX       = 01; {constantes para las coordenadas x}
  CorY       = 120;{constantes para las coordenadas y}

{constantes para los eventos producidos por los botones}
  evBtn0   = #01;
  evBtn1   = #02;
  evBtn2   = #03;
  evBtn3   = #04;
  evBtn4   = #05;
  evBtn5   = #06;
  evBtn6   = #07;
  evBtn7   = #08;
  evBtn8   = #09;
  evBtn9   = #10;
  evBtnSum = #12;
  evBtnRes = #13;
  evBtnMul = #14;
  evBtnDiv = #15;
  evBtnDec = #16;
  evBtnIgu = #17;
  evBtnBrrT= #18;
  evBtnBrrA= #19;
  evEdtEntrada = #20;
  evBtnInf = #21;

type
{tipo dialogo : informacion}
  DlgInfoPtr = ^TDlgInfo;

  TDlgInfo = object(TForm)
               EtiqInfo : TEtiq;
               BtnOk: TBtn;
               procedure iniciar (titu, info: string;c : DlgInfoPtr);
               function ManEv (Tipo : TipoEv; Ev : char;var resp:boolean):char;Virtual;
              end;

{tipo dialogo : confirmacin}
  DlgConfPtr = ^TDlgConf;
  TDlgConf = object(TForm)
               EtiqMsm : TEtiq;
               BtnSi, BtnNo : TBtn;
               respuesta : boolean;
               procedure iniciar (titu, preg: string;c : DlgConfPtr);
               function ManEv (Tipo : TipoEv; Ev : char;var resp:boolean):char;Virtual;
             end;

{tipo dialogo : calculadora}
 FormCalPtr = ^TFormCal;
 TFormCal = object (TForm)
            EdtResp : TEdit;{edit para entrada de datos y respuestas}
            BtnSum , {boton de suma}
            BtnRes , {boton de resta}
            BtnMul , {Boton de multiplicacin}
            BtnDiv , {boton de divisin}
            BtnDec , {boton del decimal}
            BtnIgu , {Boton igual}
            BtnInf , {boton que genera la muestra de creditos}
            BtnBrrT, {boton para borrar todos los datos}
            BtnBrrA : TBtn; {boton para borrar dato anterior}
            TBtnsNm : array [0..9] of TBtn; {tabla de botones de numeros del 0 al 9}
            OP : char;
            Cant1, Cant2 : real;
            procedure iniciar (C : ControlPtr);
            function ManEv(Tipo:TipoEv;Ev:char;var resp:boolean):char;Virtual;
            procedure Info;
            procedure CamDec;
            procedure Sum;
            procedure Res;
            procedure Mul;
            procedure Din;
            procedure Igu;
           end;

implementation

 procedure TDlgInfo.iniciar (titu, Info: string;c : DlgInfoPtr);
 begin
   Largo (200);
   Alto (90);
   crear (200,200,Titu);
   Actualizar;
   BtnOk.Crear (50,60,'Aceptar',evSi,c);
   EtiqInfo.Alto (55);
   EtiqInfo.largo (180);
   EtiqInfo.Ajustable := true;
   EtiqInfo.Crear (1,1,info,c);
   Agregar (@BtnOk);
   Agregar (@EtiqInfo);
   while CaptEv <> #0 do
 end;

 function TDlgInfo.ManEv (Tipo : TipoEv; Ev : char;var resp:boolean):char;
 begin
   inherited ManEv (Tipo, Ev, Resp);

   case Tipo of
     Usuario : case Ev of
                  cEsc : destruir
                 end;

     Objeto : case Ev of
                  evSi :    destruir
                end;
   end;
 end;

{***********************************************************************}
{***********************************************************************}

 procedure TDlgConf.iniciar (Titu, preg : string; c: DlgConfPtr);
 begin
   Largo (220);
   Alto (100);
   crear (200,200,Titu);
   Actualizar;
   BtnNo.Crear (120,60,' No ',evNo,c);
   BtnSi.Crear (10,60,' S ',evSi,c);
   BtnSi.EvAccion := evSi;
   EtiqMsm.Alto (55);
   EtiqMsm.Largo (200);
   EtiqMsm.Ajustable := true;
   EtiqMsm.Crear (1,1,Preg,c);
   Agregar (@BtnSi);
   Agregar (@BtnNo);
   Agregar (@EtiqMsm);
   while CaptEv <> #0 do
 end;

 function TDlgConf.ManEv (Tipo : TipoEv; Ev : char;var resp:boolean):char;
 begin
   inherited ManEv (Tipo, Ev, Resp);
   case Tipo of
     Usuario : case Ev of
                  cEsc : begin
                          respuesta := false;
                          destruir
                        end;
                 end;

     Objeto : case Ev of
                  evSi : begin
                           respuesta := true;
                           destruir
                         end;

                  evNo : begin
                           respuesta := false;
                           destruir
                         end;
                end;
   end;
 end;

{***********************************************************************}
{***********************************************************************}
 procedure TFormCal.iniciar (C : ControlPtr);
 var
   i : byte;
   Hor,Ver : integer;
   s : string[2];
 begin
   OP := #0;
   Largo (120);
   Alto (185);
   Crear (150,150,'Calculadora');
{actualiza el formulario}
   Actualizar;

{crea el boton  de suma}
   BtnSum.Crear (CorX + (Separacion * 3), CorY + Separacion, '+',evBtnSum,c);
   Agregar (@BtnSum);
{crea el boton  de resta}
   BtnRes.Crear (CorX + (Separacion * 3), CorY,'-',evBtnRes,c);
   Agregar (@BtnRes);
{Inicia el boton  de Multiplicacion}
   BtnMul.Crear (CorX + (Separacion * 3), CorY - Separacion, '*',evBtnMul,c);
   Agregar (@BtnMul);
{Inicia el boton  de Divisin}
   BtnDiv.Crear (CorX + (Separacion * 3), CorY - (Separacion * 2), '/',evBtnDiv,c);
   Agregar(@BtnDiv);
   BtnDiv.EvAccion := evBtnDiv;
{Inicia el boton correspondiente al punto decimal}
   BtnDec.Crear (CorX + Separacion, CorY + Separacion, ',',evBtnDec,c);
   Agregar (@BtnDec);
{Inicia el boton que corresponde al nmero cero }
   TBtnsNm[0].Crear (CorX, CorY + Separacion, '0',evBtn0,c);
   Agregar(@TBtnsNm[0]);
{inicia el boton igual}
   BtnIgu.Crear (CorX + Separacion * 2, CorY + Separacion, '=',evBtnIgu,c);
   Agregar (@BtnIgu);
{Inicia las variables correspondientes a las coordenadas verticales y
horizontales de los botones del 1 al 9 }
   Ver := CorY;
   Hor := CorX;
{Ciclo "para"  inicia los botones de los nmeros del 1 al 9 }
   for i := 1 to 9 do
   begin
     Str(i,s);
     Case i of
       1 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn1,c);
       2 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn2,c);
       3 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn3,c);
       4 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn4,c);
       5 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn5,c);
       6 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn6,c);
       7 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn7,c);
       8 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn8,c);
       9 : TBtnsNm[i].Crear (Hor, Ver, s,evBtn9,c);
     end;{fin de caso de i}
     Agregar (@TBtnsNm[i]);
     if Hor >= CorX + (Separacion * 2) then
     begin
       Hor := CorX;
       Ver := Ver - Separacion
     end
     else
       Hor := Hor + Separacion;
   end;{fin for}
{crea el boton borrar }
   BtnBrrA.Crear (1, 30, chr(27), evBtnBrrA,c);
   Agregar (@BtnBrrA);
{crea el boton que muestra creditos}
   BtnInf.Crear (25, 30, 'Info', evBtnInf,c);
   Agregar (@BtnInf);
 {crea el boton borrar todo}
   BtnBrrT.Crear (82, 30, 'CA', evBtnBrrT,c);
   Agregar (@BtnBrrT);
{Crea el objeto Edit1 donde se realizar las entradas de datos }
   EdtResp.Largo (113);
   Edtresp.Formato (fNumero);
   EdtResp.Crear(1,1,'',c);
   EdtResp.evEntrada := evEdtEntrada;
   Agregar (@EdtResp);
{entra en el bucle principal}
   while CaptEv <> #0 do
 end;
{*****************************************************************}

 function TFormCal.ManEv(Tipo:TipoEv;Ev:char;var resp:boolean):char;
 var
    co : integer;
    n : real;
    s : string;
 begin
   Inherited ManEv (Tipo, Ev, resp);
   case tipo of
     Usuario : case Ev of
                   cEsc : Destruir;
                   '+' : sum;
                   '-' : res;
                   '*' : mul;
                   '/' : din;
                   '=',
                   cEnter : igu;
                 end;

    Objeto :case Ev of
             evBtn0 : EdtResp.Texto (EdtResp.Entrada+'0');
             evBtn1 : EdtResp.Texto (EdtResp.Entrada+'1');
             evBtn2 : EdtResp.Texto (EdtResp.Entrada+'2');
             evBtn3 : EdtResp.Texto (EdtResp.Entrada+'3');
             evBtn4 : EdtResp.Texto (EdtResp.Entrada+'4');
             evBtn5 : EdtResp.Texto (EdtResp.Entrada+'5');
             evBtn6 : EdtResp.Texto (EdtResp.Entrada+'6');
             evBtn7 : EdtResp.Texto (EdtResp.Entrada+'7');
             evBtn8 : EdtResp.Texto (EdtResp.Entrada+'8');
             evBtn9 : EdtResp.Texto (EdtResp.Entrada+'9');

             evBtnSum : Sum;

             evBtnRes : Res;

             evBtnMul : Mul;

             evBtnDiv : din;

             evBtnDec : EdtResp.Texto (EdtResp.Entrada+',');

             evBtnIgu : Igu;

             evBtnBrrT : begin
                           EdtResp.Texto ('');
                           Cant1 := 0;
                           Cant2 := 0;
                           OP := #0;
                         end;

             evBtnBrrA : begin
                           if OP = #0 then
                             Cant1 := 0
                           else
                            Cant2 := 0;
                           EdtResp.Texto ('')
                         end;
             evBtnInf : info;
            end;
   end;
 end;
{*****************************************************************}


 procedure TFormCal.Info;
 var
   DlgInfo : DlgInfoPtr;
 begin
   DlgInfo := new (DlgInfoPtr);
   DlgInfo^.iniciar ('! Creditos...', 'SofLiVen         Calculadora v0.1', DlgInfo);
   Dispose (DlgInfo)
 end;

 procedure TFormCal.CamDec;
 var
  s : string;
  i : byte;
 begin
   s := EdtResp.Entrada;
   i := pos (',', EdtResp.Entrada);
   if i > 0 then
    s[i] := '.'
   else
   begin
     i := pos ('.', EdtResp.Entrada);
     if i > 0 then
      s[i] := ','
   end;
   EdtResp.Texto (s);
 end;

 procedure TFormCal.Sum;
 var
   n : real;
   co:integer;
 begin
   CamDec;
   val (EdtResp.Entrada, n, co);
   if OP = #0 then
    Cant1 := n
   else
    cant2 := n;
   OP := '+';
   EdtResp.Texto ('')
 end;

 procedure TFormCal.Res;
 var
   n : real;
   co:integer;
 begin
   camdec;
   val (EdtResp.Entrada, n, co);
   if OP = #0 then
    Cant1 := n
   else
    cant2 := n;
   OP := '-';
   EdtResp.Texto ('')
 end;

 procedure TFormCal.Mul;
 var
   n : real;
   co:integer;
 begin
   camdec;
   val (EdtResp.Entrada, n, co);
   if OP = #0 then
    Cant1 := n
   else
    cant2 := n;
   OP := '*';
   EdtResp.Texto ('')
 end;

 procedure TFormCal.Din;
 var
  n : real;
  co:integer;
 begin
   camdec;
   val (EdtResp.Entrada, n, co);
   if OP = #0 then
    Cant1 := n
   else
    cant2 := n;
   OP := '/';
   EdtResp.Texto ('')
 end;

 procedure TFormCal.Igu;
 var
   s : string;
   n : real;
   co : integer;
   DlgErr : DlgInfoPtr;
 begin
   CamDec;
   s := EdtResp.Entrada;
   val (s, n, co);
   Cant2 :=  n;
   case OP of
    '+': cant1 := Cant1 + Cant2;

    '-': cant1 := Cant1 - Cant2;

    '*': cant1 := Cant1 * Cant2;

    '/': if Cant2 <> 0 then
           cant1 := Cant1 / Cant2
         else
         begin
           DlgErr := new (DlgInfoPtr);
           DlgErr^.iniciar ('! Advertencia','Error: Divisin por cero',DlgErr);
           Dispose (DlgErr);
         end;
   end;
   str (cant1:0:0, s);
   EdtResp.Texto (s);
   CamDec
 end;

end.