{*********************************************************************
                         ConGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTEdit;
interface
uses Graph,UTApli,Eventos;

const

 Cursor = '';

 cnEspec : set of char = [#32..#47,#58..#64,#91..#96,#123,#125,
                          #129..#154,#160..#165,#168,#173];

 cnMayus : set of char = ['A'..'Z'];

 cnMinus : set of char = ['a'..'z'];

 cnNumer : set of char = ['0'..'9',','];

 cnFecha : set of char = ['0'..'9','/'];

 cnHora : set of char = ['0'..'9',':'];

type
       TModoDespliegue = (Der,Izq);

       TFormato = (ftexto, fMayuscula, fMinuscula, fNumero, fMoneda,
                   fFecha, fHora);

       EditPtr = ^TEdit;

       TEdit = Object(TObjeto)
                   EvEntrada : char;
                   constructor Crear (x1,y1:word;s:string;Ctrl: ControlPtr);
                   destructor  Destruir;virtual;
                   function    ManEv(tipo:TipoEv; Ev:char;var Resp:boolean):char;virtual;
                   procedure   Actualizar;Virtual;
                 public
                   ModoDespliegue : TModoDespliegue;
                   procedure Costado ( c : word);
                   procedure Tope ( t : word);
                   procedure Largo ( l : word);
                   procedure Alto ( a : word);
                   procedure Color (c : byte);
                   procedure Textura (t: byte);
                   procedure Formato (f : tformato);
                   procedure BordeEstilo (b : char);
                   procedure Texto (s : string);
                   function  Entrada : String;
                   procedure Fuente (f:Tfuente);
                   function  MouseDentro : boolean;
                 private
                   MinX, MinY, MaxX, MaxY : word;
                   CorX1, CorY1, CorX2, CorY2 : word;
                   vCostado, vTope, vLargo, vAlto : word;
                   vFormato : TFormato;
                   vBordeEstilo : char;
                   vColor : Byte;
                   vTextura : Byte;
                   vFuente : TFuente;
                   vTexto:string;
                   x,y,p1:word;
                   Selini : byte;
                   ImagenAnt : Pointer;
                   X1Ant, Y1Ant, X2Ant, Y2Ant : word;
                   TamanoImagen : word;
                   CtrlPtr : ControlPtr;
                   Creado, foco : Boolean;
                   procedure Refrescar;
                   procedure Pintar;
                   function  Caben:word;
                   procedure Pone_Cursor;
                   procedure Quita_Cursor;
                   procedure Mov_Cur_Der;
                   procedure Mov_Cur_Izq;
                   procedure Mov_Cur_Ini;
                   procedure Mov_Cur_Fin;
                   procedure DelChar;
                   function  LargoTexto : Byte;
                   procedure MostrarTexto (Desde : byte);
                   function YMedio : word;
               end;


implementation

{Procedimientos Heredados}
 constructor TEdit.Crear (x1,y1:word;s:string;Ctrl: ControlPtr);
 begin
   CtrlPtr := Ctrl;
   vCostado := x1;
   vTope := y1;
   vTexto := s;
   Refrescar;
   Creado := True;
   EvOcultarMouse;
   TamanoImagen := ImageSize(CorX1,CorY1,CorX2,CorY2);
   GetMem (ImagenAnt, TamanoImagen);
   GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
   X1Ant := CorX1 - MinX;
   Y1Ant := CorY1 - MinY;
   X2Ant := MaxX - CorX2;
   Y2Ant := MaxY - CorY2;
   EvMostrarMouse;
   Actualizar
 end;


 destructor  TEdit.Destruir;
 begin
   if creado then
   begin
     EvOcultarMouse;
     PutImage (minx+X1Ant, MinY+Y1Ant, ImagenAnt^,NormalPut);
     EvMostrarMouse;
     FreeMem (ImagenAnt, TamanoImagen);
     Creado := False
  end
 end;

 function TEdit.ManEv(tipo:TipoEv; Ev:char;var Resp:boolean):char;
 var
   charPermitido : boolean;
 begin
   charPermitido := false;
   case tipo of
    Usuario : case ASCIIExtendido of
                  true  : case Ev of
                            cMouseCli: if MouseDentro Then
                                       begin
                                         repeat
                                         until EvMouseBtn = 0;
                                         Pone_Cursor;
                                         Resp := true;
                                         ManEv := #0
                                       end
                                       else
                                        begin
                                          Resp := false;
                                          ManEv := Ev;
                                          Quita_Cursor
                                        end;

                            cFlchIzq,
                            cFlchAbj : begin
                                         Mov_Cur_Izq;
                                         Resp := true;
                                         ManEv := EvEntrada;
                                        end;

                            cFlchDer,
                            cFlchArr : begin
                                         Mov_Cur_Der;
                                         Resp := true;
                                         ManEv := EvEntrada;
                                        end;

                            cInicio :begin
                                       Mov_Cur_Ini;
                                       Resp := true;
                                       ManEv := EvEntrada;
                                     end;

                            cFin  : begin
                                      Mov_Cur_Fin;
                                      Resp := true;
                                      ManEv := EvEntrada;
                                    end;

                            cSupr  : begin
                                       DelChar;
                                       Resp := true;
                                       ManEv := EvEntrada;
                                      end;

                          else
                             Resp := false;
                             ManEv := Ev;
                         end;

                  false :case Ev of
                          cTab : if foco then
                                  begin
                                    Quita_Cursor;
                                    foco := false;
                                    ManEv := cTab;
                                    Resp := false
                                  end
                                  else
                                  begin
                                    Pone_Cursor;
                                    foco := true;
                                    ManEv := #0;
                                    Resp := true
                                  end;

                          cRetro :if Selini in [2..LargoTexto+1] then
                                  begin
                                    Delete (vTexto, Selini-1,1);
                                    Mov_Cur_Izq;
                                  end;
                           else
                            begin
                              case vFormato of
                               fTexto :if (Ev in cnEspec) or (Ev in cnMayus)or
                                          (Ev in cnMinus) or (Ev in cnNumer)then
                                        charPermitido := true;

                               fMayuscula :if (Ev in cnMayus) or
                                              (Ev in cnEspec) then
                                            charPermitido := true
                                           else
                                            if Ev in cnMinus then
                                            begin
                                              ev := UpCase (ev);
                                              charPermitido := true
                                           end;

                               fMinuscula :if (Ev in cnMinus) or
                                              (Ev in cnEspec) then
                                            charPermitido := true;

                               fNumero :if Ev in cnNumer then
                                         charPermitido := true;

                               fFecha :if Ev in cnFecha then
                                        charPermitido := true;

                               fHora :if Ev in cnHora then
                                       charPermitido := true;

                             else
                              charpermitido := false;
                             end;

                             if charPermitido then
                             begin
                               if Selini in [0..LargoTexto] then
                                Insert (Ev, vTexto, Selini)
                               else
                                vTexto := (Concat(vTexto, Ev));

                               if ModoDespliegue = Der then
                                 Mov_Cur_Der;
                             end;
                           end;
                           Resp := true;
                           ManEv := EvEntrada;
                         end;
                end;
   end;
 end;

 procedure   TEdit.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
        ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
     begin
       evOcultarMouse;
       PutImage (minX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
       X1Ant := CorX1 - MinX;
       Y1Ant := CorY1 - MinY;
       X2Ant := MaxX - CorX2;
       Y2Ant := MaxY - CorY2;
       FreeMem (ImagenAnt, TamanoImagen);
       TamanoImagen := ImageSize(CorX1, CorY1, CorX2, CorY2);
       GetMem (ImagenAnt, TamanoImagen);
       GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
     end;
     if ModoDespliegue = Der then
     begin
       x := CorX1 + 5;
       Selini := 1;
       p1 := 1
     end
     else
      begin
        Selini := LargoTexto;
        p1 := LargoTexto;
        x := CorX2 - TextWidth (Cursor);
      end;
     EvMostrarMouse;
     Pintar;
   end
 end;


{Procedimientos Publicos}

 procedure TEdit.Costado (c: word);
 begin
   if (c > 0) Then
     vCostado :=  c
  else
   VCostado :=  1
 end;


 procedure TEdit.Tope (t : word);
 begin
   if (t > 0) Then
     vTope :=  t
    else
      vtope :=  1
 end;


 procedure TEdit.Largo (l : word);
 var
  vDefecto : word;
 begin
   with vFuente do
     SetTextStyle(Estilo, Direccion, Tamano);

   vDefecto := Textwidth (vTexto) + 7;
   vDefecto := vDefecto + ((vDefecto * 50) div 100);

   if (l > TextWidth(Cursor) * 2) Then
     vLargo := l
   else
     begin
       vLargo := 0;
       while  (vLargo < vDefecto) and
              (vCostado + vLargo < CtrlPtr^.MaxX) do
         inc(vLargo);
     end
 End;


 procedure TEdit.alto (a : word);
 var
   vDefecto : word;
 begin
   with vFuente do
     SetTextStyle(Estilo, Direccion, Tamano);

   vDefecto := TextHeight (vTexto) + 7;
   vDefecto := vDefecto + ((vDefecto * 50) div 100);

   if (a > ((vDefecto * 50) div 100)) And (vTope + a < CtrlPtr^.MaxY) Then
     vAlto := a
   else
    begin
      vAlto := 0;
      while (vAlto < vDefecto) and
            (vTope + vAlto < CtrlPtr^.MaxY) do
       inc(vAlto);
     end
 end;


 procedure TEdit.Color (c: byte);
 begin
   if (c > 0) and (c < GetMaxColor) Then
     vColor := c
   else
     vColor := MapColor[8]
 end;


 procedure TEdit.Textura (t: byte);
 begin
   if (t > 0) And ( t < 10) Then
    vTextura := t
   else
    vTextura := 1;
 end;

 procedure TEdit.BordeEstilo (b : char);
 begin
   vBordeEstilo := b
 end;

 procedure TEdit.Formato (f : tformato);
 begin
   vFormato := f
 end;

 procedure TEdit.Texto (s: String);
 begin
   vTexto := s;
   x := CorX1 + 5;
   p1 := 1;
   SelIni := 1;
   if creado then
     mostrartexto (p1)
 end;

 function TEdit.entrada : String;
 begin
   Entrada := vTexto
 end;

 procedure TEdit.Fuente ( f : Tfuente);
 begin
   if (f.Color > 0) then
      vFuente := f
   else
     vFuente.Color := MapColor[9]
 end;

 function  TEdit.MouseDentro : boolean;
 begin
   if ((MouseY >= CorY1) and (MouseY <= CorY2) and
       (MouseX >= CorX1) and (MouseX <= CorX2))then
    MouseDentro := true
   else
    MouseDentro := false
 end;

{Procedimientos Privados}

 procedure TEdit.Refrescar;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Textura (vTextura);
   Formato (vFormato);
   Fuente (vFuente);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
 end;


 procedure TEdit.Pintar;
 begin
   if Creado then
   begin
     EvOcultarMouse;
     SetFillStyle (vTextura,vColor);
     Bar (CorX1,CorY1,CorX2,CorY2);
     SetColor (MapColor[2]);
     rectangle (CorX1,CorY1,CorX2,CorY2);
     SetColor (MapColor[3]);
     rectangle (CorX1+1,CorY1+1,CorX2-1,CorY2-1);

     case vBordeEstilo of
       #0 : SetColor (MapColor[3]);
     end;
     Line (CorX1+2,CorY1+2,CorX2-2,CorY1+2);
     Line (CorX1+2,CorY1+2,CorX1+2,CorY2-2);

     case vBordeEstilo of
       #0 : SetColor (MapColor[2]);
     end;
     Line (CorX2-2,CorY1+2,CorX2-2,CorY2-2);
     Line (CorX1+2,CorY2-2,CorX2-2,CorY2-2);
     EvMostrarMouse;
     MostrarTexto (1)
   end
 end;

 function TEdit.Caben : word;
 var i, x1:Integer;
 begin
   x1 := CorX1 + 5;
   if Length(vTexto) > 0 then
     for i := 0 to Length(vTexto) do
      if x1  < CorX2 - TextWidth(Cursor) then
        x1 := x1 + TextWidth(Cursor)
      else
        begin
          Caben := i;
          Break;
        end
 end;

 procedure TEdit.Pone_Cursor;
 begin
   if Creado then
   begin
     with vFuente do
       SetTextStyle(Estilo, Direccion, Tamano);
     SetColor (vFuente.Color);
     if MouseDentro then
      EvOcultarMouse;
     OutTextXY (x, y, Cursor);
     with vFuente do
       SetTextStyle(Estilo, Direccion, Tamano);
     SetColor (vColor);
     OutTextXY (x, y, vTexto[SelIni]);
     if not Mousevisible then
      EvMostrarMouse
  end
 end;

 procedure TEdit.Quita_Cursor;
 begin
   with vFuente do
     SetTextStyle(Estilo, Direccion, Tamano);
   SetColor (vColor);
   if MouseDentro then
    EvOcultarMouse;
   OutTextXY (x,y,Cursor);
   SetColor (vFuente.Color);
   if Selini in [1..Length(vTexto)] then
    OutTextXY (x,y,vTexto[Selini]);
   if not MouseVisible then
    EvMostrarMouse;
 end;


 procedure TEdit.Mov_Cur_Der;
 begin
   Quita_Cursor;
   if Selini <= Length(vTexto) then
   begin
     inc (Selini);
     if x < CorX2 - (TextWidth (Cursor) * 2 ) then
       x := x + TextWidth (Cursor);
     if (Selini > p1 + Caben) then
     begin
       MostrarTexto (Selini - Caben);
       inc (p1)
     end
      else
       MostrarTexto (p1);
   end;
   Pone_Cursor;
  end;

 procedure TEdit.Mov_Cur_Izq;
 begin
   Quita_Cursor;
   if Selini > 1 then
   begin
     Dec (Selini);
     if x  > CorX1 + 5 THEN
       x := x - TextWidth (Cursor);
     case ModoDespliegue of
      Der : if Selini < p1 THEN
             Begin
               MostrarTexto (Selini);
               Dec (p1);
             end
             else
               MostrarTexto (p1);
             end;
     end;
    Pone_Cursor;
 end;

 procedure TEdit.Mov_Cur_Ini;
 begin
   x := CorX1 + 5;
   Selini := 1;
   p1 := 1;
   MostrarTexto (p1);
   Pone_Cursor;
 end;

 procedure TEdit.Mov_Cur_Fin;
 begin
 end;

 procedure TEdit.DelChar;
 begin
   if Selini in [1..Length(vTexto)] then
   begin
     Delete (vTexto, Selini,1);
     MostrarTexto(p1);
   end;
   Pone_Cursor;
 end;

 function TEdit.LargoTexto : byte;
 begin
   LargoTexto := Length (vTexto)
 end;


 procedure TEdit.MostrarTexto (Desde : Byte);
 var i,Xaux : Integer;
 begin
   if Creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     with vFuente do
     begin
       SetTextStyle(Estilo, Direccion, Tamano);
       setcolor(Color);
     end;
     y := YMedio - ((TextHeight(vTexto)*50) div 100);
     SetFillStyle (vTextura, vColor);
     Bar (CorX1+3, CorY1+3, CorX2-3, CorY2-3);
     case ModoDespliegue of
      Der : begin
              Xaux := CorX1 + 5;
              if Desde < 1 then
               Desde := 1;
              for i := Desde to LargoTexto do
               if Xaux < CorX2 - TextWidth (Cursor) Then
               begin
                OutTextXY (Xaux, y , vTexto[i]);
                 Xaux := Xaux + TextWidth (Cursor);
               end;
            end;

     Izq : begin
             Xaux := CorX2 - TextWidth(Cursor);
             if (Desde < 1) or (Desde > LargoTexto) then
              Desde := LargoTexto;
             for i := LargoTexto Downto Desde do
              if Xaux  > CorX1 + TextWidth (Cursor) Then
              begin
                OutTextXY (Xaux, y, vTexto[i]);
                Xaux := Xaux - TextWidth (Cursor);
              end;
           end;
   end;{fin de caso}
  if not MouseVisible then
    EvMostrarMouse;
   if foco then
    Pone_Cursor;
  end;
 end;

 function  TEdit.YMedio:word;
 begin
   YMedio := (CorY1 + CorY2) div 2
 end;

end.