{*********************************************************************
                           ConGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTEtiq;
interface
uses Graph,UTApli,Eventos;
type
      EtiqPtr = ^TEtiq;

      TEtiq = Object(TObjeto)
                   constructor Crear(x1, y1 : word; s: string;Ctrl:ControlPtr);
                   destructor  Destruir;virtual;
                   procedure   Actualizar;Virtual;
                public
                   Ajustable : boolean;
                   procedure Costado ( c : word);
                   procedure Tope ( t : word);
                   procedure Largo ( l : word);
                   procedure Alto ( a : word);
                   procedure Color (c : byte);
                   procedure Textura (t: byte);
                   procedure BordeEstilo (b : char);
                   procedure Texto (s : string);
                   procedure Fuente (f:Tfuente);
                   function  MouseDentro : boolean;
                private
                   MinX,MinY,MaxX,MaxY : Word;
                   CorX1, CorY1, CorX2, CorY2 : Word;
                   vCostado, vTope, vLargo, vAlto : word;
                   vBordeEstilo : char;
                   vColor : Byte;
                   vTextura : Byte;
                   vFuente : TFuente;
                   vTexto:string;
                   ImagenAnt : Pointer;
                   X1Ant, Y1Ant, X2Ant, Y2Ant : word;
                   TamanoImagen : word;
                   CtrlPtr : ControlPtr;
                   Creado : Boolean;
                   procedure Refrescar;
                   procedure Pintar;
                   function  XMedio:word;
                   function  YMedio:word;
                end;
implementation

 constructor TEtiq.Crear(x1, y1 : word; s: string;Ctrl:ControlPtr);
 begin
   vCostado := x1;
   vTope := y1;
   vTexto := s;
   CtrlPtr := Ctrl;
   Refrescar;
   Creado := true;
   EvOcultarMouse;
   TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
   GetMem (ImagenAnt,TamanoImagen);
   GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
   X1Ant := CorX1 - MinX;
   Y1Ant := CorY1 - MinY;
   X2Ant := MaxX - CorX2;
   Y2Ant := MaxY - CorY2;
   evMostrarMouse;
   Actualizar
 end;

 destructor  TEtiq.Destruir;
 begin
   if creado then
   begin
     EvOcultarMouse;
     PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
     EvMostrarMouse;
     FreeMem (ImagenAnt,TamanoImagen);
     Creado := false;
   end
 end;

 procedure TEtiq.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
        ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
     begin
       PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
       X1Ant := CorX1 - MinX;
       Y1Ant := CorY1 - MinY;
       X2Ant := MaxX - CorX2;
       Y2Ant := MaxY - CorY2;
       FreeMem (ImagenAnt, TamanoImagen);
       TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
       GetMem (ImagenAnt, TamanoImagen);
       GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
     end;
     if MouseVisible = false then
      EvMostrarMouse;
     Pintar
  end
 end;

 procedure TEtiq.Costado ( c : word);
 begin
   if (c > 0) and (c < MaxX) then
    vCostado := c
   else
     vCostado := 1
 end;

 procedure TEtiq.Tope ( t : word);
 begin
   if (t > 0) and (t < MaxY) then
    Vtope := t
   else
     Vtope := 1
 end;

 procedure TEtiq.Largo ( l : word);
 var
  vDefecto : word;
 begin
   vLargo := l;
   if creado then
   begin
     with VFuente do
      SetTextStyle (Estilo, Direccion, Tamano);
      vDefecto := Textwidth (vTexto);
     vDefecto := vDefecto + ((vDefecto * 10) div 100);
      if (l > ((vDefecto * 50) div 100)) and (vCostado + l < MaxX) then
       vLargo := l
      else
       begin
         vLargo := 0;
         while(vLargo < vDefecto ) and
              (vCostado + vLargo < MaxX) do
          inc (vLargo)
       end
   end
 end;

 procedure TEtiq.Alto ( a : word);
 var
   vDefecto : word;
 begin
   Valto := a;
   if creado then
   begin
     with VFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
     vDefecto := TextHeight (vTexto);
     if (a >= Vdefecto ) and (vtope + a < MaxY) then
      vAlto := a
     else
     begin
       vAlto := 0;
       while  (vAlto < vDefecto) and
              (vTope + vAlto < MaxY) do
        inc (vAlto)
     end
  end
 end;

 procedure TEtiq.Color (c : byte);
 begin
   if (c > 0 ) and (c < GetMaxColor+1) then
    vColor := c
   else
    vColor := MapColor[0]
 end;

 procedure TEtiq.Textura (t: byte);
 begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
 end;

 procedure TEtiq.BordeEstilo (b : char);
 begin
   if b in [#0..#3] then
    vBordeEstilo := b
   else
    vBordeEstilo := #0
 end;

 procedure TEtiq.Texto (s : string);
 var
  h, v, i: word;
  l: byte;
  e : word;
 begin
   h := 0;
   v := 0;
   i := 0;
   l := 0;
   e := 0;
   vTexto := s;
   if creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     SetFillStyle (vTextura,vColor);
     bar (CorX1+1, CorY1+1, CorX2-1, CorY2-1);
     with vFuente do
     begin
       Setcolor (Color);
       SetTextStyle (Estilo, Direccion, Tamano);
     end;
     case Ajustable of
       false : begin
                 h := CorX1+1;
                 for i := 1 to length(vTexto) do
                 begin
                   if h  < CorX2 - TextWidth (vTexto[i]) then
                   begin
                     OutTextXY (h,YMedio - ((TextHeight(vTexto)*50) div 100),
                                VTexto[i]);
                     h := h + TextWidth(VTexto[i])
                   end
                  end
                end;

       true : begin
                v := CorY1+1;
                i := 1;
                l := length(vTexto);
                e := TextWidth ('')+2;
                while (l <> i ) and (v < CorY2 -1) do
                begin
                  h := CorX1+1;
                  while h < CorX2 - e do
                  begin
                    OutTextXY (h,v,VTexto[i]);
                    h := h + e;
                    inc (i)
                  end;
                  v := v + e+ 2;
                 end;
               end;
     end;{fin casos ajustable}
     if not MouseVisible then
     EvMostrarMouse
   end
 end;

 procedure TEtiq.Fuente (f:Tfuente);
 begin
   if f.Color = 0 then
   begin
    vFuente := FuenteTitulo;
    vFuente.Color := MapColor[6]
   end
 end;

 function  TEtiq.MouseDentro : boolean;
 begin
   if ((MouseY >= CorY1) and (MouseY <= CorY2) and
       (MouseX >= CorX1) and (MouseX <= CorX2))then
    MouseDentro := true
   else
   MouseDentro := false
 end;

 procedure TEtiq.Refrescar;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Fuente (vFuente);
   Textura (vTextura);
   BordeEstilo (vBordeEstilo);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
 end;

 procedure TEtiq.Pintar;
 begin
   EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   case vBordeEstilo of
     #0 : SetColor (vColor);
     #1 : SetColor (MapColor[2]);
   end;
   Line (CorX1+2,CorY1+2,CorX2-2,CorY1+2);
   Line (CorX1+2,CorY1+2,CorX1+2,CorY2-2);

  case vBordeEstilo of
    #0 : SetColor (vColor);
    #1 : SetColor (MapColor[3]);
  end;
  Line (CorX2-2,CorY1+2,CorX2-2,CorY2-2);
  Line (CorX1+2,CorY2-2,CorX2-2,CorY2-2);

  Texto (vTexto);
  EvMostrarMouse
 end;

 function  TEtiq.XMedio:word;
 begin
   XMedio := (CorX1 + CorX2) div 2
 end;

 function  TEtiq.YMedio:word;
 begin
   YMedio := (CorY1 + CorY2) div 2
 end;
end.