{*********************************************************************
                         UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTForm;
interface
uses Eventos, Graph, UTApli;

type  TForm = Object(TControl)
                  constructor Crear (x1, y1 : word; s: string);
                  destructor Destruir;virtual;
                  procedure Actualizar;Virtual;
                  function ManEv (Tipo : TipoEv; Ev : char;var resp:boolean):char;Virtual;
                public
                  Marco : boolean;
                  procedure Titulo (s: string);
                  procedure Costado (c: word);
                  procedure Tope (t: word);
                  procedure largo (l: word);
                  procedure Alto (a: word);
                  procedure Color (c: byte);
                  procedure Textura (t: byte);
                  function  MouseDentro : boolean;
                  procedure Mover (x1, y1:word);
                  function XMedio:word;
                  function YMedio:word;
                  function AreaExtensa : boolean;
                private
                   vTitulo : string;
                   CorX1,CorY1,CorX2,CorY2 : word;
                   vCostado, vTope, vLargo, vAlto : word;
                   CorTitulo : array [0..4] of word;
                   AltoTitulo : word;
                   VColor : Byte;
                   VTextura : Byte;
                   ImagenAnt1, ImagenAnt2 : Pointer;
                   X1Ant,Y1Ant, X2Ant,Y2Ant : word;
                   difx, dify : word;
                   SelxAnt, SelyAnt : word;
                   TamanoImagen : integer;
                   Creado : Boolean;
                   Procedure Refrescar;
                   Procedure Pintar;
                   procedure PintarMarcoTitulo;
                   procedure PintarBtnCerrar (modo : byte);
                   procedure PintarMarco;
                   function MouseDentroBtnCerrar : boolean;
                   function BtnCerrarPulsado : boolean;
                   function MouseDentroTitulo : boolean;
                   procedure CaptRastro;
                   procedure MoverRastro (x1, y1:word);
               end;

implementation
 {Procedimientos heredados}
 constructor TForm.Crear (x1, y1 : word; s: string);
 begin
   vCostado := x1;
   vTope := y1;
   vTitulo := s;
   Refrescar;
   inherited crear (CorX1, CorY1, CorX2, CorY2);
   Creado := true;
   if MouseDentro then
    EvOcultarMouse;
   if AreaExtensa then
   begin
     TamanoImagen := ImageSize (CorX1, CorY1, XMedio, CorY2);
     GetMem (ImagenAnt1,TamanoImagen);
     GetImage (CorX1, CorY1, XMedio, CorY2, ImagenAnt1^);
     GetMem (ImagenAnt2,TamanoImagen);
     GetImage (XMedio+1, CorY1, CorX2, CorY2, ImagenAnt2^);
   end
   else
    begin
     TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
     GetMem (ImagenAnt1,TamanoImagen);
     GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt1^);
    end;
   X1Ant := CorX1;
   Y1Ant := CorY1;
   X2Ant := CorX2;
   Y2Ant := CorY2;
   if not MouseVisible then
    evMostrarMouse;
   Actualizar;
 end;

 destructor TForm.Destruir;
 begin
   if creado then
   begin
     Inherited Destruir;
     if MouseDentro then
      EvOcultarMouse;
     if AreaExtensa then
     begin
       putImage (X1Ant, Y1Ant, ImagenAnt1^, NormalPut);
       freeMem (ImagenAnt1,TamanoImagen);
       putImage (XMedio+1, CorY1, ImagenAnt2^, NormalPut);
       freeMem (ImagenAnt2,TamanoImagen);
     end
     else
      begin
        putImage (X1Ant, Y1Ant, ImagenAnt1^, NormalPut);
        freeMem (ImagenAnt1,TamanoImagen);
      end;
     Creado := false;
     if not MouseVisible then
      EvMostrarMouse;
   end
 end;

 procedure TForm.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     EvOcultarMouse;
     if (X1Ant <> CorX1) or (Y1Ant <> CorY1) or
        (X2Ant <> CorX1) or (Y2Ant <> CorY1) then
     begin
       if AreaExtensa then
       begin
         PutImage (X1Ant, Y1Ant, ImagenAnt1^, NormalPut);
         FreeMem (ImagenAnt1, TamanoImagen);
         PutImage (XMedio, CorY1, ImagenAnt2^, NormalPut);
         FreeMem (ImagenAnt2, TamanoImagen);
       end
        else
        begin
          PutImage (X1Ant, Y1Ant, ImagenAnt1^, NormalPut);
          FreeMem (ImagenAnt1, TamanoImagen);
        end;
       X1Ant := CorX1;
       Y1Ant := CorY1;
       X2Ant := CorX2;
       Y2Ant := CorY2;
       if AreaExtensa then
       begin
         TamanoImagen := ImageSize (CorX1, CorY1, XMedio, CorY2);
         GetMem (ImagenAnt1,TamanoImagen);
         GetImage (CorX1, CorY1, XMedio, CorY2, ImagenAnt1^);
         GetMem (ImagenAnt2,TamanoImagen);
         GetImage (XMedio+1, CorY1, CorX2, CorY2, ImagenAnt2^);
       end
       else
        begin
          TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
          GetMem (ImagenAnt1, TamanoImagen);
          GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt1^);
        end;
     end;
      EvMostrarMouse;
     Pintar;
     inherited Actualizar;
    end;
 end;

 function TForm.ManEv (Tipo : TipoEv; Ev : char;var resp:boolean) : char;
 begin
   if ASCIIExtendido then
    if Ev = cMouseCli then
     if MouseDentroTitulo then
     begin
       CaptRastro;
       while EvMouseBtn = 1 do
        MoverRastro (MouseX, MouseY);
     end
     else
       if MouseDentroBtnCerrar then
         if BtnCerrarPulsado then
           Destruir;
 end;

{Procedimientos Publicos}
 procedure TForm.Titulo (s: string);
 var
  h: word;
  i : byte;
 begin
   vTitulo := s;
   CorTitulo[0] := CorX1 + 3;{cordenada x1 para la barra del titulo}
   CorTitulo[1] := CorY1 + 2;{cordenada y1 para la barra del titulo}
   CorTitulo[2] := CorX2 - 20;{cordenada x2 para la barra del titulo}
   {cordenada y2 para la barra del titulo}
   with FuenteTitulo do
    SetTextStyle (Estilo, Direccion, Tamano);
   CorTitulo[3] := CorY1 + TextHeight ('')+ 7+
                   (((TextHeight ('') * 50 ) div 100));

   AltoTitulo := CorTitulo[3] - CorTitulo[1];
   CorTitulo[4] := CorTitulo[1] + (AltoTitulo div 2);
   CorTitulo[4] := CorTitulo[4] - (TextHeight ('') div 2);
   if creado then
   begin
     EvOcultarMouse;
     SetFillStyle (vTextura,MapColor[5]);
     bar (CorTitulo[0]-1, CorTitulo[1], CorTitulo[2], CorTitulo[3]);
     h := CorTitulo[0]+1;
     with FuenteTitulo do
       SetTextStyle (Estilo, Direccion, Tamano);

     for i := 1 to length(vTitulo) do
     begin
       if h + TextWidth (vTitulo[i]) < CorTitulo[2]  then
       begin
         Setcolor (mapcolor[3]);
         OutTextXY (h-1,CorTitulo[4]-1, VTitulo[i]);
         Setcolor (FuenteTitulo.Color);
         OutTextXY (h,CorTitulo[4], VTitulo[i]);
         h := h + TextWidth(VTitulo[i])
       end
     end;
      EvMostrarMouse
   end
 end;

 procedure TForm.Costado (c: word);
 begin
   if (c > 0) and (c < GetMaxX) then
    vCostado := c
   else
     vCostado := 1
 end;


 procedure TForm.Tope (t: word);
 begin
   if (t > 0) and (t < GetMaxY) then
    Vtope := t
   else
     Vtope := 1;
 end;

 procedure TForm.Largo (l: word);
 begin
   if (l > 10 ) and (vCostado + l < GetMaxX) then
    vLargo := l
   else
    begin
      vLargo := 0;
      while(vCostado + vLargo < vCostado + 100 ) and
           (vCostado + vLargo < GetMaxX) do
        inc (vLargo)
   end
 end;

 procedure TForm.Alto ( a : word);
 begin
   if (a > 5) and (vtope + AltoTitulo + a < GetMaxY) then
    vAlto := a
   else
      while  (vTope + AltoTitulo + vAlto < vTope + 100) and
             (vTope + AltoTitulo + vLargo < GetMaxY) do
       Inc (vAlto)
 end;


 procedure TForm.Color (c: byte);
 Begin
   if (c > 0) and (c < GetMaxColor+1) then
    vColor := c
   else
    vColor := MapColor[0]
 end;


 procedure TForm.Textura (t: byte);
 begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
 end;

 function TForm.MouseDentro : boolean ;
 begin
   if ((MouseX >= CorX1) and (MouseX <= CorX2) and
       (MouseY >= CorY1) and (MouseY <= CorY2))then
     MouseDentro := true
   else
     MouseDentro := false
 end;

 procedure TForm.Mover (x1, y1:word);
 begin
   if Creado then
   begin
     Costado (x1);
     Tope (y1);
     Actualizar
   end
 end;

 function  TForm.XMedio:word;
 begin
   XMedio := (CorX1 + CorX2) div 2
 end;

 function  TForm.YMedio:word;
 begin
   YMedio := (CorY1 + CorY2) div 2
 end;

 function TForm.AreaExtensa : boolean;
 begin
   if vLargo * vAlto > 87000 then
      AreaExtensa := true
   else
     AreaExtensa := false
 end;
{Procedimientos privados}

 procedure TForm.refrescar;
 begin
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Textura (vTextura);
   Titulo (vTitulo);
   CorX1 := vCostado;
   CorY1 := vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + AltoTitulo + vAlto;
   if creado then
   begin
     X := CorX1 + 3;
     Y := CorY1 + AltoTitulo + 4;
     MaxX := CorX2 - 4;
     MaxY := CorY2 - 4;
  end;
 end;


 procedure TForm.Pintar;
 begin
   EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   SetColor (MapColor[2]);
   Line (CorX1,CorY1,CorX2,CorY1);
   Line (CorX1,CorY1,CorX1,CorY2);
   SetColor (MapColor[3]);
   Line (CorX2,CorY1,CorX2,CorY2);
   Line (CorX1,CorY2,CorX2,CorY2);
   EvMostrarMouse;
   Titulo (vTitulo);
   PintarMarcoTitulo;
   PintarBtnCerrar (0);
   if Marco then
    PintarMarco;
 end;

 procedure TForm.PintarMarcoTitulo;
 begin
   if MouseDentroTitulo then
    evOcultarMouse;
   SetColor (MapColor[4]);
   Line (CorTitulo[0], CorTitulo[3], CorX2-2, CorTitulo[3]);
   Line (CorX1+2, CorTitulo[1], CorX2-2, CorTitulo[1]);
   Line (CorTitulo[2], CorTitulo[1],CorTitulo[2], CorTitulo[3]);
  if not MouseVisible then
   evMostrarMouse;
 end;

 procedure TForm.PintarBtnCerrar (modo : byte);
 var
   Medx : word;
 begin
   if creado then
   begin
     if MouseDentroBtnCerrar then
      EvOcultarMouse;
     case modo of
      0: SetColor (MapColor[2]);
      1: SetColor (MapColor[3]);
     end;
     Line (CorTitulo[2]+2, CorTitulo[1]+1,CorTitulo[2]+2, CorTitulo[3]-1);
     Line (CorTitulo[2]+2, CorTitulo[1]+1,CorX2-2, CorTitulo[1]+1);
     case modo of
      0: SetColor (MapColor[3]);
      1: SetColor (MapColor[2]);
     end;
     Line (CorX2-2,CorY1+2,CorX2-2,CorTitulo[3]-1);
     Line (CorTitulo[2]+2, CorTitulo[3]-1,CorX2-2, CorTitulo[3]-1);
     with FuenteTitulo do
       SetTextStyle (0, 0, Tamano);
     Setcolor (mapColor[6]);
     Medx := (((CorTitulo[2]+2) + (CorX2-2)) Div 2) - (TextWidth ('X') div 2);
     OutTextXY (Medx,CorTitulo[4],'x');
     if not MouseVisible then
      EvMostrarMouse;
  end;
 end;

 procedure TForm.PintarMarco;
 begin
   if MouseDentro then
    EvOcultarMouse;
   SetColor (MapColor[4]);
   Rectangle(CorX1+1, CorY1 + 1, CorX2 - 2, CorY2 - 2);
   if not MouseVisible then
    EvMostrarMouse;
 end;

 function Tform.MouseDentroBtnCerrar : boolean;
 var
   Btnx1 , Btny1, Btnx2, BtnY2 : word;
 begin
   Btnx1 := CorTitulo[2]+2;
   Btny1 := CorTitulo[1]+1;
   Btnx2 := CorX2-2;
   BtnY2 := CorTitulo[3]-1;
   if ((MouseX >= Btnx1) and (MouseX <= Btnx2) and
       (MouseY >= Btny1) and (MouseY <= Btny2))then
     MouseDentroBtnCerrar := true
   else
     MouseDentroBtnCerrar := false
 end;

 function TForm.BtnCerrarPulsado : boolean;
 begin
   repeat
     if MouseDentroBtnCerrar then
     begin
       PintarBtnCerrar (1);
       repeat  until (EvMouseBtn <> 1) or (MouseDentroBtnCerrar = false);
     end
      else
       begin
         PintarBtnCerrar (0);
         repeat  until (EvMouseBtn <> 1) or (MouseDentroBtnCerrar);
       end;
   until EvMouseBtn <> 1;
   PintarBtnCerrar (0);
   if MouseDentroBtnCerrar then
    BtnCerrarPulsado := true
   else
    BtnCerrarPulsado := false
 end;

 function TForm.MouseDentroTitulo : boolean;
 begin
   if ((MouseX >= CorX1) and (MouseX <= CorTitulo[2]) and
       (MouseY >= CorY1) and (MouseY <= CorTitulo[3]))then
    MouseDentroTitulo := true
   else
    MouseDentroTitulo := false
 end;

 procedure TForm.CaptRastro;
 begin
   difx := MouseX - Corx1;
   dify := MouseY - Cory1;
   SelyAnt := MouseY;
   SelxAnt := MouseY;
 end;

 procedure TForm.MoverRastro (x1, y1:word);
 var
   cxr, cyr : word;
 begin
   {direfrencia entre el click del mouse y las cordenadas del formulario}
   cxr := x1 - difx;
   cyr := y1 - dify;
   if (SelxAnt <> x1) and (SelyAnt <> y1) then
   begin
     {establece las nuevas coordenadas}
     costado(cxr);
     Tope (cyr);
     SelxAnt := x1;
     SelyAnt := y1;
     mover (cxr, cyr);
     Actualizar;
   end
 end;

end.