{*********************************************************************
                          UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
{$O+}
{$F+}
unit UTLista;
interface
uses Eventos, UTApli, Graph, crt;
type

  LItemPtr = ^LItem;

  LItem = object
            constructor crear (t : string; e : LItemPtr);
           private
            texto : string;
            sig, ant : LItemPtr;
            n : word;
          end;

  ListaPtr = ^TLista;

  TLista = object (TObjeto)
             evSeleccion, evClick : char;
             constructor Crear(x1, y1 : word; I : LItemPtr; Ctrl:ControlPtr);
             destructor Destruir;virtual;
             procedure Actualizar;Virtual;
             function ManEv (Tipo : TipoEv; Ev: char;var resp:boolean): char;Virtual;
             procedure Costado (c : word);
             procedure Tope (t : word);
             procedure Largo (l: word);
             procedure Alto (a : word);
             procedure Fuente (f : TFuente);
             procedure Color (c : Byte);
             procedure Textura (t : byte);
             procedure habilitado (e : boolean);
             procedure BordeEstilo (bs : char);
             procedure Agregar (s : string);
             function MouseDentro : boolean;
             function Seleccion : string;
             function IndiceActual : word;
             function ActualPtr : LItemPtr;
             function Caben : word;
             procedure Eliminar(l : LItemPtr);
            private
              MinX, MinY, MaxX, MaxY : word;
              CorX1, CorY1, CorX2, CorY2 : word;
              vCostado, vTope, vLargo, vAlto : word;
              vMarcaX : word;
              BarraY : boolean;
              vColor,vTextura :byte;
              vFuente : TFuente;
              vhabilitado : boolean;
              vBordeEstilo : char;
              CtrlPtr : ControlPtr;
              Creado, resaltado:boolean;
              X1Ant,Y1Ant, X2Ant, Y2Ant : word;
              ImagenAnt : pointer;
              TamanoImagen : word;
              foco : boolean;
              lista, Actual, ip1 : LItemPtr;
              max : word;
              PosX, PosY : word;
              procedure pintar;
              procedure Refrescar;
              procedure Numerar;
              procedure Mov_Abj;
              procedure Mov_Arr;
              procedure Marcar;
              procedure DesMarcar (t : byte);
              procedure MostrarItems;
              function XMedio:word;
              function YMedio:word;
              function ItemSelec : boolean;
              procedure PintarBtnAbj (t : byte);
              procedure PintarBtnArr (t : byte);
              procedure PintarBarraY;
              function MouseDentroBtnAbj : boolean;
              function BtnAbjPulsado : boolean;
              function MouseDentroBtnArr : boolean;
              function BtnArrPulsado : boolean;
           end;

implementation

  constructor LItem.crear (t : string; e : LItemPtr);
  begin
    Texto := t;
    sig := e;
  end;

  constructor TLista.Crear(x1, y1 : word; I : LItemPtr; Ctrl:ControlPtr);
  var
    p, p1 : LItemPtr;
  begin
    vCostado := x1;
    vTope := y1;
    CtrlPtr := Ctrl;
    p := i;
    while p <> nil do
    begin
      p1 := p^.sig;
      p^.sig := lista;
      lista^.Ant := p;
      lista := p;
      p := p1;
    end;
    Refrescar;
    Creado := true;
    if MouseDentro then
     EvOcultarMouse;
    TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
    GetMem (ImagenAnt,TamanoImagen);
    GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
    X1Ant := CorX1 - MinX;
    Y1Ant := CorY1 - MinY;
    X2Ant := MaxX - CorX2;
    Y2Ant := MaxY - CorY2;
    if not MouseVisible then
     evMostrarMouse;
    Actualizar;
  end;

  destructor TLista.Destruir;
  begin
   if creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
     if not MouseVisible then
     EvMostrarMouse;
     FreeMem (ImagenAnt,TamanoImagen);
     Creado := false;
   end
  end;

  procedure TLista.Actualizar;
  begin
    Refrescar;
    if creado then
    begin
      if MouseDentro then
       EvOcultarMouse;
     if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
        ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
     begin
       PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
       X1Ant := CorX1 - MinX;
       Y1Ant := CorY1 - MinY;
       X2Ant := MaxX - CorX2;
       Y2Ant := MaxY - CorY2;
       FreeMem (ImagenAnt, TamanoImagen);
       TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
       GetMem (ImagenAnt, TamanoImagen);
       GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
    end;
     if not MouseVisible then
      EvMostrarMouse;
     Pintar;
   end
  end;

  function TLista.ManEv (Tipo : TipoEv; Ev: char;var resp:boolean): char;
  begin
    case tipo of
      usuario : case ASCIIExtendido of
                 true : case Ev of
                         cMouseCli: case MouseDentro of
                                      true : begin
                                               if MouseDentroBtnArr and
                                                 BtnArrPulsado then
                                               begin
                                                 if actual <> nil then
                                                   Mov_Arr;
                                                 ManEv := evSeleccion;
                                                 resp := true
                                               end
                                               else
                                               if MouseDentroBtnAbj and
                                                 BtnAbjPulsado then
                                               begin
                                                 if actual <> nil then
                                                   Mov_Abj;
                                                 ManEv := evSeleccion;
                                                 resp := true
                                               end
                                               else
                                                if ItemSelec then
                                                begin
                                                  Resp := true;
                                                  ManEv := evClick
                                                end;
                                             end;

                                      false : begin
                                                Resp := false;
                                                ManEv := Ev;
                                                DesMarcar (1)
                                              end;
                                    end;

                         cFlchAbj : begin
                                      if actual <> nil then
                                       Mov_Abj;
                                      ManEv := evSeleccion;
                                      resp := true
                                    end;

                         cFlchArr : begin
                                      if actual <> nil then
                                       Mov_Arr;
                                      ManEv := evSeleccion;
                                      resp := true
                                    end;
                        else
                         ManEv := #0;
                         Resp := false
                        end;

                 false : case ev of
                         cTab : if foco then
                                begin
                                  DesMarcar (1);
                                  foco := false;
                                  ManEv := cTab;
                                  Resp := false;
                                end
                                else
                                begin
                                  Marcar;
                                  foco := true;
                                  ManEv := #0;
                                  Resp := true
                                end;
                        else
                         ManEv := #0;
                         Resp := false
                        end;

                 end;
      end;
  end;

  procedure TLista.Costado (c : word);
  begin
    if (c > 0) and (c < MaxX) then
     vCostado := c
    else
      vCostado := 1
  end;

  procedure TLista.Tope (t : word);
  begin
    if (t > 0) and (t < MaxY) then
     vtope := t
    else
     vtope := 1;
  end;

  procedure TLista.Largo (l: word);
  var
   vDefecto : word;
  begin
    vLargo := l;
    if creado then
    begin
      with VFuente do
       SetTextStyle (Estilo, Direccion, Tamano);
       vDefecto := 100;
       if (l > ((vDefecto * 50) div 100)) and (vCostado + l < MaxX) then
        vLargo := l
       else
       begin
         vLargo := 0;
         while(vCostado + vLargo < vCostado + vDefecto ) and
              (vCostado + vLargo < MaxX) do
           inc (vLargo)
       end
   end
  end;

  procedure TLista.Alto (a : word);
  var
   vDefecto : word;
  begin
    vAlto := a;
    if creado then
    begin
      with VFuente do
       SetTextStyle (Estilo, Direccion, Tamano);
      vDefecto := 80;
      if (a > (Vdefecto * 50) div 100) and (vtope + a < MaxY) then
        vAlto := a
      else
      begin
        vAlto := 0;
        while  (vTope + vAlto < vTope + vDefecto) and
               (vTope + vAlto < MaxY) do
         inc (vAlto)
      end
    end;
 end;

  procedure TLista.Fuente (f : TFuente);
  begin
    if f.Color = 0 then
    begin
      vFuente := FuenteTitulo;
      vFuente.Color := MapColor [9]
    end
    else
    vFuente := f
  end;

  procedure TLista.Color (c : Byte);
  begin
    if (c > 0) and (c < GetMaxColor) then
     vColor := c
    else
     vColor := MapColor[8]
  end;

  procedure TLista.Textura (t : byte);
  begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
  end;

  procedure TLista.habilitado (e : boolean);
  begin
    vHabilitado := e
  end;

  procedure TLista.BordeEstilo (bs : char);
  begin
   if bs in [#0..#3] then
    vBordeEstilo := bs
  end;

  procedure TLista.Agregar (s : string);
  var
    k : LItemPtr;
  begin
    k := new (LItemPtr);
    k^.Texto := s;
    k^.sig := lista;
    lista^.Ant := k;
    lista := k;
    Actualizar
  end;

  function TLista.MouseDentro : boolean ;
  begin
    if ((MouseY >= CorY1) and (MouseY <= CorY2) and
        (MouseX >= CorX1) and (MouseX <= CorX2))then
      MouseDentro := true
    else
      MouseDentro := false
  end;

 function TLista.Seleccion : string;
 begin
   if Actual <> nil then
    Seleccion := Actual^.Texto
   else
    Seleccion := '';
 end;

 function Tlista.IndiceActual : word;
 begin
   if Actual <> nil then
    Indiceactual := Actual^.n
   else
     IndiceActual := 0
 end;

 function TLista.Caben : word;
 var
  y, i  : word;
  p : LItemPtr;
 begin
   p := lista;
   y := CorY1 + 3;
   i := 0;
   with VFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
   while (p <> nil) and (y + TextHeight(p^.Texto) < CorY2-2) do
   begin
     y := y + TextHeight (p^.Texto)+7;
     inc (i);
     p := p^.Sig
   end;
   caben := i
 end;

 procedure TLista.pintar;
 begin
   if MouseDentro then
    EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   case vBordeEstilo of
     #00: SetColor (MapColor[2]);
     #01 : SetColor (0);
   end;
   Line (CorX1, CorY1, CorX2, CorY1);
   Line (CorX1, CorY1, CorX1, CorY2);

   Line (CorX1+1, CorY2-1, CorX2-1, CorY2-1);
   Line (CorX2-1, CorY1+1, CorX2-1, CorY2-1);
   case vBordeEstilo of
     #00: SetColor (MapColor[3]);
     #01: SetColor (0);
   end;
   Line (CorX1, CorY2, CorX2, CorY2);
   Line (CorX2, CorY1, CorX2, CorY2);

   Line (CorX1+1, CorY1+1, CorX2-1, CorY1+1);
   Line (CorX1+1, CorY1+1, CorX1+1, CorY2-1);
   if not MouseVisible then
    evMostrarMouse;
   MostrarItems;
   if foco then
    Marcar;
   if BarraY then
    PintarBarraY;
 end;

 procedure TLista.Refrescar;
 var
   dif : word;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   if PosY <> 0 then
     dif := PosY - (CorY1+3);
   Actual := Lista;
   ip1 := lista;
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Textura (vTextura);
   Fuente (vFuente);
   BordeEstilo (vBordeEstilo);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
   if PosY = 0 then
    PosY := CorY1 + 3
   else
    PosY := (CorY1+3) + Dif;
   PosX := CorX1 + 3;
   numerar;
   if caben < max then
   begin
     vMarcaX := CorX2 - 20;
     BarraY := true;
   end
   else
    begin
     vMarcaX := CorX2 - 2;
     BarraY := false;
    end;
 end;

  function  TLista.XMedio:word;
  begin
    XMedio := (CorX1 + CorX2) div 2
  end;

  function  TLista.YMedio:word;
  begin
    YMedio := (CorY1 + CorY2) div 2
  end;

  procedure TLista.Numerar;
  var
   p : LItemPtr;
  begin
    p := Lista;
    max := 0;
    while p <> nil do
    begin
      inc (max);
      p^.n := max;
      p := p^.Sig
    end;
  end;

 procedure TLista.Mov_Abj;
 var
   x : word;
   i : byte;
 begin
   if (Actual^.n >= caben) then
   begin
     if (actual^.sig <> nil) then
     begin
       ip1 := ip1^.sig;
       actual := actual^.sig;
       MostrarItems;
       Marcar;
     end;
   end
   else
    if Actual^.Sig <> nil then
    begin
      DesMarcar(0);
      Actual := Actual^.Sig;
      if PosY + TextHeight (Actual^.Texto)+7 < CorY2-2 then
      PosY := PosY + TextHeight (Actual^.Texto)+7;
      Marcar;
     end;
 end;

 procedure TLista.Mov_Arr;
 var
   x : word;
   i : byte;
 begin
   if (Actual <> ip1) and (actual <> nil) then
   begin
     DesMarcar(0);
     Actual := Actual^.Ant;
     if PosY - (TextHeight (Actual^.Texto))+7 > CorY1+2 then
       PosY := PosY - (TextHeight (Actual^.Texto)+7);
     Marcar
   end
   else
    if (Actual^.Ant <> nil) and (actual^.n > 1) then
    begin
      ip1 := ip1^.Ant;
      Actual := ip1;
      MostrarItems;
      marcar
    end;
  end;

 procedure TLista.Marcar;
 var
   i : byte;
   x : word;
 begin
   x := PosX+2;
   if MouseDentro then
    evOcultarMouse;
   SetFillStyle (vTextura, MapColor[7]);
   if actual <> nil then
    Bar (PosX, PosY, vMarcaX-1, PosY + TextHeight(Actual^.Texto)+2)
   else
    begin
     SetLineStyle(DottedLn, 0, NormWidth);
     rectangle (PosX, PosY, vMarcaX-1, PosY + TextHeight(Actual^.Texto)+2);
     SetLineStyle(0, 0, NormWidth);
    end;
   SetColor (vColor);
   with VFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
   if Actual <> nil then
    for i := 1 to length(Actual^.Texto) do
     if x + TextWidth (Actual^.Texto[i]) < vMarcaX  then
     begin
       OutTextXY (x, PosY+1, Actual^.Texto[i]);
       x := x + TextWidth (Actual^.Texto[i]);
     end;
   if not MouseVisible then
    evMostrarMouse
 end;

 procedure TLista.DesMarcar (t : byte);
 var
   i : byte;
   x : word;
 begin
   x := PosX+2;
   if MouseDentro then
    evOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (PosX, PosY, VMarcaX-1, PosY + TextHeight(Actual^.Texto)+2);
   if t = 1 then
   begin
     SetLineStyle(DottedLn, 0, NormWidth);
     rectangle (PosX, PosY, vMarcaX-1, PosY + TextHeight(Actual^.Texto)+2);
     SetLineStyle(0, 0, NormWidth);
   end;
   SetColor (vFuente.Color);
   with vFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
   if Actual <> nil then
    for i := 1 to length(Actual^.Texto) do
     if x + TextWidth (Actual^.Texto[i]) <  vMarcaX then
     begin
       OutTextXY (x, PosY+1, Actual^.Texto[i]);
       x := x + TextWidth (Actual^.Texto[i]);
     end;
   if not MouseVisible then
    evMostrarMouse
 end;

 procedure TLista.MostrarItems;
 var
  x, y  : word;
  i : byte;
  p : LItemPtr;
 begin
   p := ip1;
   y := CorY1 + 3;
   if MouseDentro then
    evOcultarMouse;
   SetFillStyle (vTextura, vcolor);
   Bar (CorX1+2,CorY1+2, vMarcaX-1,CorY2-2);
   SetColor (vFuente.Color);
   with VFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
   while (p <> nil) and (y + TextHeight(p^.Texto) < CorY2-2) do
   begin
     x := PosX+2;
     for i := 1 to length(p^.Texto) do
       if x + TextWidth (p^.Texto[i]) < vMarcaX then
       begin
         OutTextXY (x, y, p^.Texto[i]);
         x := x + TextWidth(p^.Texto[i])
       end;
     y := y + TextHeight (p^.Texto)+7;
     p := p^.Sig
   end;
   if not MouseVisible then
    evMostrarMouse
 end;

 function TLista.ItemSelec: boolean;
 var
   p : LItemPtr;
   y : word;
 begin
   repeat
   until EvMouseBtn = 0;
   DesMarcar (0);
   p := ip1;
   y := CorY1 + 3;
   while (p <> nil) and ((y + TextHeight(p^.Texto) < CorY2-2)) do
   begin
     if ((MouseY >= Y) and (MouseY <= Y + TextHeight(p^.Texto)) and
         (MouseX >= PosX+2) and (MouseX < vMarcaX))then
     begin
       Actual := p;
       PosY := y;
       ItemSelec := true;
       break;
     end
     else
       ItemSelec := false;
     y := y + TextHeight (p^.Texto)+7;
     p := p^.sig
   end;
   Marcar
 end;

 procedure TLista.PintarBtnAbj (t : byte);
 var
   x1, y1 , x2, y2 : word;
 begin
   x1 := vMarcaX+1;
   y1 := CorY2-20;
   x2 := CorX2-3;
   y2 := CorY2-3;
   if MouseDentroBtnAbj then
    evOcultarmouse;
   case t of
     0 : begin
           SetColor (MapColor[2]);
           Line (x1, y1, x2, y1);
           Line (x1, y1, x1, y2);
           SetColor (MapColor[3]);
           Line (x1, y2, x2, y2);
           Line (x2, y1, x2, y2);
         end;

     1 : begin
           SetColor (MapColor[3]);
           Line (x1, y1, x2, y1);
           Line (x1, y1, x1, y2);
           SetColor (MapColor[2]);
           Line (x1, y2, x2, y2);
           Line (x2, y1, x2, y2);
         end;
   end;
   SetColor (MapColor[3]);
   SetTextStyle (0,1,0);
   OutTextXY (((x1+x2) div 2) + 4, ((y1+y2) div 2)-3, chr(17));
   if not MouseVisible then
     evMostrarMouse
 end;

 procedure TLista.PintarBtnArr (t : byte);
 var
   x1, y1 , x2, y2 : word;
 begin
   x1 := vMarcaX+1;
   y1 := CorY2-40;
   x2 := CorX2-3;
   y2 := CorY2-22;

   if MouseDentroBtnArr then
    evOcultarmouse;
   case t of
     0 : begin
           SetColor (MapColor[2]);
           Line (x1, y1, x2, y1);
           Line (x1, y1, x1, y2);
           SetColor (MapColor[3]);
           Line (x1, y2, x2, y2);
           Line (x2, y1, x2, y2);
         end;

     1 : begin
           SetColor (MapColor[3]);
           Line (x1, y1, x2, y1);
           Line (x1, y1, x1, y2);
           SetColor (MapColor[2]);
           Line (x1, y2, x2, y2);
           Line (x2, y1, x2, y2);
         end;
   end;
   SetColor (MapColor[3]);
   SetTextStyle (0,1,0);
   OutTextXY (((x1+x2) div 2)+4, ((y1+y2) div 2)-3, chr(16));
   if not MouseVisible then
     evMostrarMouse
 end;

 procedure TLista.PintarBarraY;
 var
   x1, y1 , x2, y2 : word;
 begin
   if MouseDentro then
    evOcultarMouse;
   x1 := vMarcaX;
   y1 := CorY1+2;
   x2 := CorX2-2;
   y2 := CorY2-2;
   SetFillStyle (vTextura, MapColor[0]);
   Bar (x1, y1, x2, y2);
   SetColor (MapColor[3]);
   Line (x1, y1, x2, y1);
   Line (x1, y1, x1, y2);
   SetColor (MapColor[2]);
   Line (x1, y2, x2, y2);
   Line (x2, y1, x2, y2);
   if not MouseVisible then
    evMostrarMouse;
   pintarBtnArr (0);
   PinTarBtnAbj (0);
 end;

 function TLista.MouseDentroBtnAbj : boolean;
 var
   x1, y1 , x2, y2 : word;
 begin
   x1 := vMarcaX+1;
   y1 := CorY2-20;
   x2 := CorX2-3;
   y2 := CorY2-3;
    if ((MouseY >= y1) and (MouseY <= y2) and
        (MouseX >= x1) and (MouseX <= x2))then
      MouseDentroBtnAbj := true
    else
      MouseDentroBtnAbj := false
 end;

 function Tlista.BtnAbjPulsado : boolean;
 begin
   if MouseDentroBtnAbj then
   begin
     PintarBtnAbj (1);
     delay (100)
   end
   else
    begin
      PintarBtnAbj (0);
      delay (100)
    end;
   PintarBtnAbj (0);
   BtnAbjPulsado := MouseDentroBtnAbj
 end;

 function TLista.MouseDentroBtnArr : boolean;
 var
   x1, y1 , x2, y2 : word;
 begin
   x1 := vMarcaX+1;
   y1 := CorY2-40;
   x2 := CorX2-3;
   y2 := CorY2-22;
   if ((MouseY >= y1) and (MouseY <= y2) and
        (MouseX >= x1) and (MouseX <= x2))then
      MouseDentroBtnArr := true
    else
      MouseDentroBtnArr := false
 end;

 function Tlista.BtnArrPulsado : boolean;
 begin
   if MouseDentroBtnArr then
   begin
     PintarBtnArr (1);
     delay (100)
   end
   else
    begin
      PintarBtnArr (0);
      delay (100)
    end;
   PintarBtnArr (0);
   BtnArrPulsado := MouseDentroBtnArr
 end;

 function TLista.ActualPtr : LItemPtr;
 begin
   ActualPtr := Actual
 end;

 procedure TLista.Eliminar (l : LitemPtr);
 var p : LItemPtr;
 begin
   if l = lista then
   begin
     Dispose(l);
     l := l^.sig
   end
   else
     begin
       p := lista;
       while p^.sig <> l do
        p := p^.sig;

       p^.sig := l^.sig;
       p^.Sig^.ant := p^.sig;
       dispose (l);
       lista := p;
       Actual := lista
     end;
 end;

end.