{*********************************************************************
                         UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
*********************************************************************}

unit UTMemo;
interface
uses Eventos, UTApli, Graph;
const
 Cursor = '';

type

  LinPtr = ^TLin;

  TLin = object
            constructor crear(t : string; e : LinPtr);
          private
           texto : string;
           n : word;
           sig, ant : LinPtr;
         end;

  MemoPtr = ^TMemo;

  TMemo = object (TObjeto)
            evEntrada : char;
            constructor Crear(x1, y1 : word; Lin: LinPtr; Ctrl:ControlPtr);
            destructor Destruir;virtual;
            procedure Actualizar;virtual;
            function ManEv (Tipo : TipoEv; Ev: char;var resp:boolean): char;virtual;
           public
            procedure Costado (c : word);
            procedure Tope (t : word);
            procedure Largo (l: word);
            procedure Alto (a : word);
            procedure Fuente (f : TFuente);
            procedure Color (c : Byte);
            procedure Textura (t : byte);
            procedure habilitado (e : boolean);
            procedure BordeEstilo (bs : char);
            function MouseDentro : boolean ;
            procedure AgrLin ( s: string);
           private
            MinX, MinY, MaxX, MaxY : word;
            CorX1, CorY1, CorX2, CorY2 : word;
            vCostado, vTope, vLargo, vAlto : word;
            vMarcaX, vMarcaY : word;
            CursX, CursY : word;
            PosX, PosY : word;
            SelIni : byte;
            MaxLineas : word;
            vColor,vTextura :byte;
            vFuente : TFuente;
            vhabilitado : boolean;
            vBordeEstilo : char;
            CtrlPtr : ControlPtr;
            Creado, resaltado:boolean;
            X1Ant,Y1Ant, X2Ant, Y2Ant : word;
            ImagenAnt : pointer;
            TamanoImagen : word;
            foco : boolean;
            p1X : byte;
            vlineas, Actual, p1Y : LinPtr;
            procedure pintar;
            procedure Refrescar;
            procedure MostrarLineas( desdeX : byte);
            procedure Mostrar_Cursor;
            procedure Ocultar_Cursor;
            procedure Mov_Cur_Der;
            procedure Mov_Cur_Izq;
            procedure Mov_Cur_Abj;
            procedure Mov_Cur_Arr;
            procedure Mov_Cur_Ini;
            procedure Mov_Cur_Fin;
            procedure DelChar;
            function LargoLinAct : byte;
            function cabenX : word;
            function cabenY : word;
            procedure Numerarlineas;
         end;

implementation
 constructor TLin.crear (t : string; e : LinPtr);
 begin
   Texto := t;
   sig := e;
 end;

 constructor TMemo.Crear (x1, y1 : word; Lin: LinPtr; Ctrl:ControlPtr);
  var
    p, p1 : LinPtr;
 begin
   vCostado := x1;
   vTope := y1;
   CtrlPtr := Ctrl;
   p := Lin;
   if (vlineas = nil) then
   begin
     vLineas := new(LinPtr);
     vLineas^.Texto := '';
     vLineas^.sig := nil;
     vLineas^.Ant := nil;
   end
   else
   while p <> nil do
   begin
     p1 := p^.sig;
     p^.sig := vLineas;
     vlineas^.Ant := p;
     vLineas := p;
     p := p1;
   end;
   Actual := vlineas;
   p1Y := vLineas;
   Selini := 1;
   p1X := 1;
   Refrescar;
   CursX := posX;
   CursY := PosY;
   Creado := true;
   if MouseDentro then
    EvOcultarMouse;
   TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
   GetMem (ImagenAnt,TamanoImagen);
   GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
   X1Ant := CorX1 - MinX;
   Y1Ant := CorY1 - MinY;
   X2Ant := MaxX - CorX2;
   Y2Ant := MaxY - CorY2;
   if not MouseVisible then
    evMostrarMouse;
   Actualizar
 end;

 destructor TMemo.Destruir;
 begin
   if creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
     if not MouseVisible then
      EvMostrarMouse;
     FreeMem (ImagenAnt,TamanoImagen);
     Creado := false;
   end
 end;

 procedure TMemo.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     if MouseDentro then
      EvOcultarMouse;
     if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
        ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
     begin
       PutImage (MinX + X1Ant, MinY + Y1Ant, ImagenAnt^, NormalPut);
       X1Ant := CorX1 - MinX;
       Y1Ant := CorY1 - MinY;
       X2Ant := MaxX - CorX2;
       Y2Ant := MaxY - CorY2;
       FreeMem (ImagenAnt, TamanoImagen);
       TamanoImagen := ImageSize (CorX1, CorY1, CorX2, CorY2);
       GetMem (ImagenAnt, TamanoImagen);
       GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
     end;
     if not MouseVisible then
      EvMostrarMouse;
     Pintar;
  end
 end;

 function TMemo.ManEv (Tipo : TipoEv; Ev: char;var resp:boolean): char;
 begin
   case tipo of
    Usuario : case ASCIIExtendido of
                  true  : case Ev of
                            cMouseCli: if MouseDentro Then
                                       begin
                                         repeat
                                         until EvMouseBtn = 0;
                                         Mostrar_Cursor;
                                         Resp := true;
                                         ManEv := #0
                                       end
                                       else
                                        begin
                                          Resp := false;
                                          ManEv := Ev;
                                          Ocultar_Cursor
                                        end;

                            cFlchIzq : begin
                                         Mov_Cur_Izq;
                                         Resp := true;
                                         ManEv := EvEntrada;
                                        end;

                            cFlchDer : begin
                                         Mov_Cur_Der;
                                         Resp := true;
                                         ManEv := EvEntrada;
                                        end;

                            cFlchAbj :begin
                                        Mov_Cur_Abj;
                                        Resp := true;
                                        ManEv := EvEntrada;
                                        end;
                            cFlchArr :begin
                                        Mov_Cur_Arr;
                                        Resp := true;
                                        ManEv := EvEntrada;
                                        end;

                            cInicio :begin
                                       Mov_Cur_Ini;
                                       Resp := true;
                                       ManEv := EvEntrada;
                                     end;

                            cFin  : begin
                                      Mov_Cur_Fin;
                                      Resp := true;
                                      ManEv := EvEntrada;
                                    end;

                            cSupr  : begin
                                       DelChar;
                                       Resp := true;
                                       ManEv := EvEntrada;
                                      end;

                          else
                             Resp := false;
                             ManEv := Ev;
                         end;

                  false :case Ev of
                          cTab : if foco then
                                  begin
                                    Ocultar_Cursor;
                                    foco := false;
                                    ManEv := cTab;
                                    Resp := false
                                  end
                                  else
                                  begin
                                    Mostrar_Cursor;
                                    foco := true;
                                    ManEv := #0;
                                    Resp := true
                                  end;

                          cEnter : begin
                                     AgrLin (' ');
                                     Mov_Cur_Abj;
                                     Resp := true;
                                     ManEv := EvEntrada;
                                   end;

                          cRetro :if Selini in [2..LargoLinAct+1] then
                                  begin
                                    Delete (Actual^.Texto, Selini-1,1);
                                    Mov_Cur_Izq;
                                  end;
                           else
                             begin
                               if Selini in [0..LargoLinAct] then
                                 Insert (Ev, Actual^.Texto, Selini)
                               else
                                 Actual^.Texto := Actual^.Texto + Ev;
                               Mov_Cur_Der
                             end;
                           Resp := true;
                           ManEv := EvEntrada;
                         end;
                end;
   end;

 end;

 procedure TMemo.Costado (c : word);
 begin
   if (c > 0) and (c < MaxX) then
    vCostado := c
   else
     vCostado := 1
 end;

 procedure TMemo.Tope (t : word);
 begin
   if (t > 0) and (t < MaxY) then
    Vtope := t
   else
     Vtope := 1
 end;

 procedure TMemo.Largo (l: word);
 var
  vDefecto : word;
 begin
   vLargo := l;
   if creado then
   begin
     with VFuente do
      SetTextStyle (Estilo, Direccion, Tamano);

      vDefecto := 100;

      if (l > ((vDefecto * 50) div 100)) and (vCostado + l < MaxX) then
       vLargo := l
      else
      begin
        vLargo := 0;
        while(vCostado + vLargo < vCostado + vDefecto ) and
             (vCostado + vLargo < MaxX) do
          inc (vLargo)
      end
   end
 end;

 procedure TMemo.Alto (a : word);
 var
   vDefecto : word;
 begin
   vAlto := a;
   if creado then
   begin
     with VFuente do
      SetTextStyle (Estilo, Direccion, Tamano);
     vDefecto := 100;

     if (a > (Vdefecto * 50) div 100) and (vtope + a < MaxY) then
      vAlto := a
     else
     begin
       vAlto := 0;
       while  (vTope + vAlto < vTope + vDefecto) and
              (vTope + vAlto < MaxY) do
        inc (vAlto)
     end
   end;
 end;

 procedure TMemo.Fuente (f : TFuente);
 begin
   if f.Color = 0 then
   begin
    vFuente := FuenteTitulo;
    vFuente.Color := MapColor [6]
   end
 end;

 procedure TMemo.Color (c : Byte);
 begin
   if (c > 0) and (c < GetMaxColor) then
    vColor := c
   else
    vColor := MapColor[8]

 end;

 procedure TMemo.Textura (t : byte);
 begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
 end;

 procedure TMemo.habilitado (e : boolean);
 begin
    vHabilitado := e
 end;

 procedure TMemo.BordeEstilo (bs : char);
 begin
   if bs in [#0..#3] then
    vBordeEstilo := bs
 end;

 function TMemo.MouseDentro : boolean ;
 begin
   if ((MouseY >= CorY1) and (MouseY <= CorY2) and
       (MouseX >= CorX1) and (MouseX <= CorX2))then
     MouseDentro := true
   else
     MouseDentro := false
 end;

 procedure TMemo.AgrLin ( s: string);
 var
   k, aux : LinPtr;
   n : word;
 begin
   if creado then
   begin
     k := new (LInPtr);
     k^.Texto := s;
     k^.sig := nil;
     k^.ant := vlineas;
     if vlineas = nil then
      vLineas := k
     else
      begin
        aux := vlineas;
        while (aux^.n < maxlineas) and (aux <> nil) do
         aux := aux^.sig;
        k^.sig := aux^.sig;
        aux^.sig := k
     end;
     numerarlineas;
     mostrarlineas(p1x)
   end;
 end;

 procedure TMemo.Pintar;
 begin
   if MouseDentro then
    EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   SetColor (MapColor[3]);
   rectangle (CorX1,CorY1,CorX2-1,CorY2-1);
   SetColor (MapColor[2]);
   Line (CorX2,CorY1,CorX2,CorY2);
   Line (CorX1,CorY2,CorX2,CorY2);
   Mostrarlineas(1);
   if not MouseVisible then
    evMostrarMouse
 end;

 procedure TMemo.Refrescar;
 var
   dif : word;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   if PosY <> 0 then
     dif := PosY - (CorY1+3);
   Costado (vCostado);
   Tope (vTope);
   Largo (vLargo);
   Alto (vAlto);
   Color (vColor);
   Textura (vTextura);
   Fuente (VFuente);
   BordeEstilo (vBordeEstilo);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
   if PosY = 0 then
    PosY := CorY1 + 3
   else
    PosY := (CorY1+3) + Dif;
   PosX := CorX1 + 3;
   vMarcaX := CorX2 -2;
   vMarcaY := CorY2 -2;
 end;

 procedure TMemo.MostrarLineas(DesdeX : byte);
 var
  x, y  : word;
  i : byte;
  p : linPtr;
 begin
   p := p1Y;
   y := posY;
   SetFillStyle (vTextura, vcolor);
   Bar (posX,posY, vMarcaX, vMarcaY);
   SetColor (vFuente.Color);
   with VFuente do
     SetTextStyle (Estilo, Direccion, Tamano);
   while (p <> nil) and (y < vMarcaY -  TextHeight(p^.Texto) ) do
   begin
     x := PosX;
     if DesdeX < 1 then
       DesdeX := 1;
     if DesdeX <= length(p^.Texto) then
     for i := DesdeX to length(p^.Texto) do
       if x < vMarcaX -TextWidth (Cursor) then
       begin
         OutTextXY (x, y, p^.Texto[i]);
         x := x + TextWidth(Cursor)
       end;
     y := y + TextHeight (Cursor)+7;
     p := p^.Sig
   end;
 end;

 procedure TMemo.Mostrar_Cursor;
 begin
   if Creado then
   begin
     with vFuente do
       SetTextStyle(Estilo, Direccion, Tamano);
     SetColor (vFuente.Color);
     if MouseDentro then
      EvOcultarMouse;
     OutTextXY (CursX, Cursy, Cursor);
     with vFuente do
       SetTextStyle(Estilo, Direccion, Tamano);
     SetColor (vColor);
     if Selini in [1..Length(Actual^.Texto)] then
      OutTextXY (CursX, CursY, Actual^.Texto[SelIni]);
     if not Mousevisible then
      EvMostrarMouse
  end
 end;

 procedure TMemo.Ocultar_Cursor;
 begin
   if creado then
   begin
     with vFuente do
       SetTextStyle(Estilo, Direccion, Tamano);
     SetColor (vColor);
     if MouseDentro then
      EvOcultarMouse;
     OutTextXY (CursX, CursY, Cursor);
     SetColor (vFuente.Color);
     if Selini in [1..Length(Actual^.Texto)] then
      OutTextXY (CursX, CursY, Actual^.Texto[Selini]);
     if not MouseVisible then
      EvMostrarMouse;
   end;
 end;

 procedure TMemo.Mov_Cur_Der;
 begin
   Ocultar_Cursor;
   if Selini <= Length(Actual^.Texto) then
   begin
     inc (Selini);
     if CursX < vMarcaX - (TextWidth (Cursor) * 2) then
       CursX := CursX + TextWidth (Cursor);
     if (Selini >= p1X + CabenX) then
      inc (p1X);
     MostrarLineas (p1X);
   end;
   Mostrar_Cursor;
 end;

 procedure TMemo.Mov_Cur_Izq;
 begin
   Ocultar_Cursor;
   if Selini > 1 then
   begin
     Dec (Selini);
     if CursX  > PosX then
       CursX := CursX - TextWidth (Cursor);
     if Selini < p1X then
     begin
       MostrarLineas (Selini);
       Dec (p1X);
     end
     else
       MostrarLineas (p1X);
   end;
   Mostrar_Cursor;
 end;

 procedure TMemo.Mov_Cur_Abj;
 var
   x : word;
   i : byte;
 begin
   Ocultar_Cursor;
   if (Actual^.n < cabenY) and (actual^.sig <> nil)then
   begin
     Actual := Actual^.sig;
     CursY := CursY + TextHeight (Cursor)+7;
   end
   else
    if Actual^.Sig <> nil then
    begin
      Actual := Actual^.Sig;
      p1Y := p1Y^.sig;
    end;
  if selini > length(Actual^.Texto) then
  begin
    i := selini - length(Actual^.Texto);
    cursX := cursX - (TextHeight(cursor)*i);
    selini := length(Actual^.Texto);
  end;
  MostrarLineas (p1x);
  Mostrar_Cursor
 end;

 procedure TMemo.Mov_Cur_Arr;
 var
   i : byte;
 begin
   Ocultar_Cursor;
   if (Actual^.n > p1Y^.n) and (actual^.ant <> nil) then
   begin
     Actual := Actual^.Ant;
     CursY := CursY - (TextHeight (Actual^.Texto)+7);
   end
   else
    if (Actual^.Ant <> nil) then
    begin
      p1Y := p1Y^.Ant;
      Actual := p1Y;
    end;

  if selini > length(Actual^.Texto) then
  begin
    i := selini - length(Actual^.Texto);
    cursX := cursX - (TextHeight(cursor)*i);
    selini := length(Actual^.Texto);
  end;
   MostrarLineas (p1x);
   Mostrar_Cursor
 end;

 function TMemo.cabenX : word;
 var i, x1:Integer;
 begin
   x1 := posX;
   if Length(Actual^.Texto) > 0 then
     for i := 0 to Length(Actual^.Texto) do
      if x1  < vMarcaX - TextWidth(Cursor) then
        x1 := x1 + TextWidth(Cursor)
      else
        begin
          CabenX := i;
          Break;
        end
 end;

 function TMemo.cabenY : word;
 begin
 end;

 procedure TMemo.Mov_Cur_Ini;
 begin
   CursX := posX;
   Selini := 1;
   p1X := 1;
   MostrarLineas (p1X);
   Mostrar_Cursor;
 end;

 procedure TMemo.Mov_Cur_Fin;
 begin
 end;

 procedure TMemo.DelChar;
 begin
   if Selini in [1..Length(Actual^.Texto)] then
   begin
     Delete (Actual^.Texto, Selini,1);
   end
   else
    if Actual^.sig <> nil then
    begin
      if Actual = p1y then
       p1Y := p1Y^.sig;
       Actual := Actual^.sig;
    end;
   MostrarLineas (p1X);
   Mostrar_Cursor;
 end;

 function TMemo.LargoLinAct : byte;
 begin
   LargoLinAct := length (actual^.Texto)
 end;

 procedure TMemo.Numerarlineas;
  var
   p : LinPtr;
 begin
   p := vLineas;
   MaxLineas := 0;
   while p <> nil do
   begin
     inc (maxLineas);
     p^.n := maxLineas;
     p := p^.Sig
   end;
 end;

end.