{*********************************************************************
                           UniGrapa
                    Software Libre Venezolano
  Autor : Robert Bruno
  Fecha : Enero 2005
  Pass : Venezuela
**********************************************************************}
unit UTMenu;
interface
uses Eventos, UTApli, Graph;
type
    TipoITem = (ITem, Sub);

    TipoDespliege = (Hor, Ver);

    ItemPtr = ^TItem;

    TItem = object
              constructor crear(nom: string; T:char; i:ItemPtr);
             private
              nombre : string;
              TclRap : char;
              sig : ItemPtr;
              Tipo : TipoItem;
            end;

    SubMenuPtr = ^SubMenu;
    SubMenu  = object (TItem)
                  constructor crear(nom: string;Sub, i:ItemPtr);
                 private
                   SigSub : ITemPtr;
                end;

    MenuPtr = ^TMenu;

    TMenu = object (TObjeto)
              Ajustable : boolean;
              constructor crear (Ctrl : controlPtr; Itm : ItemPtr);
              destructor destruir;virtual;
              function ManEv(tipo:TipoEv; Ev:char;var Resp:boolean):char;virtual;
              procedure Actualizar;Virtual;
              procedure Tope (t : word);
              procedure Costado (c : word);
              procedure color (c: byte);
              procedure textura (t: byte);
             private
              MinX, MinY, MaxX, MaxY : word;
              CorX1,CorY1,CorX2,CorY2 : word;
              vCostado, vTope, vLargo, vAlto : word;
              tDesp : TipoDespliege;
              VColor : Byte;
              VTextura : Byte;
              vFuente : TFuente;
              ImagenAnt: Pointer;
              X1Ant,Y1Ant, X2Ant,Y2Ant : word;
              TamanoImagen : integer;
              Creado : Boolean;
              Items : ItemPtr;
              CtrlPtr : controlptr;
              foco : boolean;
              desplegado : boolean;
              CorX1Item, CorX2Item : word;
              CorY1Item, CorY2Item : word;
              ItemActual : ITemPtr;
              procedure Refrescar;
              procedure Pintar;
              function XMedio:word;
              function YMedio:word;
              procedure Largo (l: word);
              procedure Alto (a : word);
              function MouseDentro : boolean;
              function MouseDentroItem : boolean;
              procedure Marcar;
              procedure DesMarcar;
              function Pulsado : boolean;
              procedure desplegar;
            end;

implementation
{****************** procedimietos de TIems *************************}

 constructor TItem.crear(nom: string; T:char; i:ItemPtr);
 begin
   Nombre := nom;
   TclRap := t;
   sig := i
 end;

{****************** procedimietos de SubMenu ************************}
 constructor SubMenu.Crear(nom: string; Sub, i:ItemPtr);
 begin
   Nombre := nom;
   sig := i;
   SigSub := Sub
 end;

{****************** procedimietos de Menu ****************************}
 constructor TMenu.crear (Ctrl : controlPtr; Itm : ItemPtr);
 begin
   Ctrlptr := Ctrl;
   items := new (ItemPtr);
   items := itm;
   Refrescar;
   Creado := true;
   EvOcultarMouse;
   TamanoImagen := ImageSize (CorX1, CorY1, XMedio, CorY2);
   GetMem (ImagenAnt,TamanoImagen);
   GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
   X1Ant := CorX1 - MinX;
   Y1Ant := CorY1 - MinY;
   X2Ant := MaxX - CorX2;
   Y2Ant := MaxY - CorY2;
   evMostrarMouse;
   Actualizar;
 end;

 destructor TMenu.destruir;
 begin
   if creado then
   begin
     Inherited Destruir;
     EvOcultarMouse;
     putImage (minX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
     freeMem (ImagenAnt,TamanoImagen);
     Creado := false;
     EvMostrarMouse;
     dispose (ITems);
   end

 end;

 function TMenu.ManEv(tipo:TipoEv; Ev:char;var Resp:boolean):char;
 var p : ItemPtr;
 begin
   case tipo of
     usuario : case ev of
                   #133 : case desplegado of
                            false : begin
                                      p := Items;
                                      CorX1Item := CorX1+1;
                                      CorY1Item := CorY1+2;
                                      CorY2Item := CorY2-2;
                                      while p <> nil do
                                      begin
                                        Corx2Item := CorX1Item+TextWidth (p^.Nombre)+7;
                                       if MouseDentroItem then
                                       begin
                                         if pulsado then
                                          desplegar;
                                        end
                                        else
                                         begin
                                           DesMarcar;
                                           ManEv := ev;
                                           Resp := false;
                                         end;
                                         CorX1Item := CorX2Item+1;
                                         p := p^.sig;
                                         ItemActual := p;
                                      end;
                                    end;
                         end;
                end;
   end
 end;

 procedure TMenu.Actualizar;
 begin
   Refrescar;
   if creado then
   begin
     EvOcultarMouse;
      if ((X1Ant <> CorX1-MinX) or (Y1Ant <> CorY1-MinY)) or
         ((X2Ant <> MaxX-CorX2) or (Y2Ant <> MaxY-CorY2)) then
      begin
        PutImage (MinX+X1Ant, MinY+Y1Ant, ImagenAnt^, NormalPut);
        FreeMem (ImagenAnt, TamanoImagen);
        X1Ant := CorX1 - MinX;
        Y1Ant := CorY1 - MinY;
        X2Ant := MaxX - CorX2;
        Y2Ant := MaxY - CorY2;
        TamanoImagen := ImageSize (CorX1, CorY1, XMedio, CorY2);
        GetMem (ImagenAnt, TamanoImagen);
        GetImage (CorX1, CorY1, CorX2, CorY2, ImagenAnt^);
     end;
     Pintar;
     EvMostrarMouse;
   end;
 end;

 procedure TMenu.Tope (t : word);
 begin
   if (t > 0) and (t < MaxY) then
    Vtope := t
   else
     Vtope := 1
 end;

 procedure TMenu.Costado (c : word);
 begin
   if (c > 0) and (c < MaxX) then
    vCostado := c
   else
     vCostado := 1
 end;

 procedure TMenu.color (c: byte);
 begin
   if (c > 0) and (c < GetMaxColor+1) then
    vColor := c
   else
    vColor := MapColor[1]
 end;

 procedure TMenu.textura (t: byte);
 begin
   if (t > 0) and (t < 9) then
    vTextura := t
   else
    vTextura := 1
 end;

 procedure TMenu.Refrescar;
 begin
   if CtrlPtr <> nil then
   begin
     MinX := CtrlPtr^.X;
     MinY := CtrlPtr^.Y;
     MaxX := CtrlPtr^.MaxX;
     MaxY := CtrlPtr^.MaxY;
   end
   else
     begin
       MinX := 1;
       MinY := 1;
       MaxX := GetMaxX;
       MaxY := GetMaxY;
     end;
   Costado (vCostado);
   Tope (vTope);
   Color (vColor);
   Textura (vTextura);
   CorX1 := MinX + vCostado;
   CorY1 := MinY + vTope;
   Largo (vLargo);
   Alto (vCostado);
   CorX2 := CorX1 + vLargo;
   CorY2 := CorY1 + vAlto;
 end;

 procedure TMenu.Pintar;
 var
    p : ItemPtr;
    x, y : word;
 begin
   EvOcultarMouse;
   SetFillStyle (vTextura,vColor);
   Bar (CorX1,CorY1,CorX2,CorY2);
   SetLineStyle(0, 0, NormWidth);
   SetColor (MapColor[2]);
   Line (CorX1, CorY1+1, CorX2, CorY1+1);
   line (CorX1, CorY2, CorX2, CorY2);
   SetColor (MapColor[3]);
   Line (CorX1, CorY1, CorX2, CorY1);
   line (CorX1, CorY2-1, CorX2, CorY2-1);
   if ajustable then
   begin
     SetColor (MapColor[2]);
     Line (CorX1, CorY1+1, CorX1, CorY2);
     line (CorX2, CorY1, CorX2, CorY2);
     SetColor (MapColor[3]);
     Line (CorX1+1, CorY1+2, CorX1+1, CorY2-1);
     line (CorX2-1, CorY1+1, CorX2-1, CorY2-1);
   end;
   with vFuente do
   begin
     Setcolor (Color);
     SetTextStyle (Estilo, Direccion, Tamano);
   end;
   p := Items;
   x := CorX1 +4;
   y := YMedio - ((TextHeight('')*50) div 100);
   while p <> nil do
   begin
     OutTextXY (x, y, p^.Nombre);
     x := x + TextWidth (p^.Nombre) + 7;
     p := p^.sig;
   end;
   EvMostrarMouse
 end;

 function  TMenu.XMedio:word;
 begin
   XMedio := (CorX1 + CorX2) div 2
 end;

 function  TMenu.YMedio:word;
 begin
   YMedio := (CorY1 + CorY2) div 2
 end;

 procedure TMenu.Largo (l: word);
 var
  vDefecto : word;
  s : string;
  p : ItemPtr;
 begin
   vLargo := l;
   s := '';
   case Ajustable of

    false : vLargo := MaxX - CorX1;

    True : begin
             with VFuente do
               SetTextStyle (Estilo, Direccion, Tamano);
             p := items;
             while p <> nil do
             begin
               s := s + p^.Nombre+' ';
               p := p^.sig
             end;
             vDefecto := Textwidth (s);
             if (l > vDefecto) and (vCostado + l < MaxX) then
               vLargo := l
             else
              begin
                vLargo := 0;
                while(vCostado + vLargo < vCostado + vDefecto ) and
                     (vCostado + vLargo < MaxX) do
                    inc (vLargo)
              end
           end
   end
 end;

 procedure TMenu.Alto (a : word);
 var
   vDefecto : word;
 begin
   vAlto := a;
   with VFuente do
    SetTextStyle (Estilo, Direccion, Tamano);
   vDefecto := TextHeight ('')+7;
   vDefecto := vDefecto + ((vDefecto * 50) div 100);
   if (a > (Vdefecto * 50) div 100) and (vtope + a < MaxY) then
    vAlto := a
   else
   begin
     vAlto := 0;
     while  (vTope + vAlto < vTope + vDefecto) and
            (vTope + vAlto < MaxY) do
      inc (vAlto)
   end
 end;

 function TMenu.MouseDentro : boolean ;
 begin
   if ((MouseY >= CorY1) and (MouseY <= CorY2) and
       (MouseX >= CorX1) and (MouseX <= CorX2))then
     MouseDentro := true
   else
     MouseDentro := false
 end;

 function TMenu.MouseDentroItem : boolean;
 begin
   if ((MouseY >= CorY1Item) and (MouseY <= CorY2Item) and
       (MouseX >= CorX1Item) and (MouseX <= CorX2Item))then
     MouseDentroITem := true
   else
     MouseDentroITem := false
 end;

 procedure TMenu.Marcar;
 begin
   if MouseDentroITem then
    evOcultarMouse;
   SetColor (MapColor[3]);
   Line (CorX1Item, CorY1Item, CorX2Item, CorY1Item);
   Line (CorX1Item, CorY1Item, CorX1Item, CorY2Item);
   SetColor (MapColor[2]);
   Line (CorX2Item, CorY1Item, CorX2Item, CorY2Item);
   Line (CorX1Item, CorY2Item, CorX2Item, CorY2Item);
  if not MouseVisible then
   evMostrarMouse
 end;

 procedure TMenu.DesMarcar;
 begin
   if MouseDentroItem then
    evOcultarMouse;
    SetColor (vColor);
    rectangle (CorX1Item, CorY1Item, CorX2Item, CorY2Item);
   if not MouseVisible then
    evMostrarMouse
 end;

 function TMenu.Pulsado : boolean;
 begin
   repeat
     if MouseDentroItem then
     begin
       Marcar;
       repeat  until (EvMouseBtn <> 1) or (MouseDentro = false);
     end
      else
       begin
         DesMarcar;
         repeat  until (EvMouseBtn <> 1) or (MouseDentro);
       end;
   until EvMouseBtn <> 1;
   Pulsado := MouseDentroItem
 end;

 procedure TMenu.desplegar;
 begin
   Marcar;
 end;
end.